--[[##################################################################################

	PXControl by alex82
	Based on Ptokax Remote Administration by Hungarista

####################################################################################

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

###################################################################################]]
local tHubSettings = {Name = {"txt_hub_name"},Addr = {"txt_login_address"},Nick = {"txt_login_nick",nil,true},Pass = {"txt_login_passwd",nil,true},
	Desc = {"txt_login_desc","chk_login_desc"},Tag = {"txt_login_tag","chk_login_tag"},Email = {"txt_login_email","chk_login_email"},
	Share = {"txt_login_share","chk_login_share"}}

tDialogs = {

Ban = function(t)
	local bandialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(bandialog,wx.NULL,"ID_DLG_BANS") then
		-- Translations --
		bandialog:SetTitle(tLang.Ban)
		tFuncs.GetCtrl("ID_CHK_NICKBAN",bandialog):SetLabel(tLang.NickBan)
		tFuncs.GetCtrl("ID_CHK_IPBAN",bandialog):SetLabel(tLang.IpBan)
		tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):SetLabel(tLang.FullBan)
		tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):SetToolTip(tLang.FullBanDisallowAll)
		tFuncs.GetCtrl("ID_STT_BANNICK",bandialog):SetLabel(tLang.Nick)
		tFuncs.GetCtrl("ID_STT_BANIP",bandialog):SetLabel(tLang.IP)
		tFuncs.GetCtrl("ID_STT_BANREASON",bandialog):SetLabel(tLang.Reason)
		tFuncs.GetCtrl("ID_STT_BANCREATEDBY",bandialog):SetLabel(tLang.BannedBy)
		tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):SetLabel(tLang.Temporary)
		local tMonths = {}
		for i = 1,12 do
			table.insert(tMonths,os.date("%b",os.time({year = 2010, month = i, day = 1})))
		end

		tFuncs.GetCtrl("ID_NUM_BANMONTH",bandialog):Clear(); tFuncs.GetCtrl("ID_NUM_BANMONTH",bandialog):Append(tMonths)
		tFuncs.GetCtrl("ID_CHK_BANPERMANENT",bandialog):SetLabel(tLang.Permanent)
		tFuncs.GetCtrl("wxID_OK",bandialog):SetLabel(tLang.Accept)
		tFuncs.GetCtrl("wxID_CANCEL",bandialog):SetLabel(tLang.Discard)
		-- Translations end --
		tFuncs.GetCtrl("ID_TXT_BANIP",bandialog):SetValidator(tValidators.IPv4)
		tFuncs.GetCtrl("ID_TXT_BANREASON",bandialog):SetValidator(tValidators.NoPipe)
		tFuncs.GetCtrl("ID_CHK_IPBAN",bandialog):Connect(wx.wxEVT_COMMAND_CHECKBOX_CLICKED,function(event)
			tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):Enable(event:IsChecked())
		end)
		tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):Connect(wx.wxEVT_COMMAND_CHECKBOX_CLICKED,function(event)
			if event:IsChecked() == true then tFuncs.GetCtrl("ID_CHK_BANPERMANENT",bandialog):SetValue(false)
			else tFuncs.GetCtrl("ID_CHK_BANPERMANENT",bandialog):SetValue(true)
			end
		end)
		tFuncs.GetCtrl("ID_CHK_BANPERMANENT",bandialog):Connect(wx.wxEVT_COMMAND_CHECKBOX_CLICKED,function(event)
			if event:IsChecked() == true then tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):SetValue(false)
			else tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):SetValue(true)
			end
		end)
		if t and #t == 6 then
			if #t[1] > 0 then
				tFuncs.GetCtrl("ID_TXT_BANIP",bandialog):SetValue(t[1])
				tFuncs.GetCtrl("ID_CHK_IPBAN",bandialog):SetValue(true)
				tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):Enable(true)
			end
			if #t[2] > 0 then
				tFuncs.GetCtrl("ID_TXT_BANNICK",bandialog):SetValue(t[2])
				tFuncs.GetCtrl("ID_CHK_NICKBAN",bandialog):SetValue(true)
			end
			tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):SetValue(t[6] == "1")
			tFuncs.GetCtrl("ID_TXT_BANREASON",bandialog):SetValue(t[4])
			tFuncs.GetCtrl("ID_TXT_BANCREATEDBY",bandialog):SetValue(t[3])
			tFuncs.GetCtrl("ID_CHK_BANPERMANENT",bandialog):SetValue(#t[5] == 0)
			tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):SetValue(#t[5] > 0)
			local tExp = os.date("*t",(tonumber(t[5]) or os.time()))
			tFuncs.GetCtrl("ID_NUM_BANDAY",bandialog):SetValue(tExp["day"])
			tFuncs.GetCtrl("ID_NUM_BANMONTH",bandialog):SetSelection(tExp["month"]-1)
			tFuncs.GetCtrl("ID_NUM_BANYEAR",bandialog):SetValue(tExp["year"])
			tFuncs.GetCtrl("ID_NUM_BANHOUR",bandialog):SetValue(tExp["hour"])
			tFuncs.GetCtrl("ID_NUM_BANMINUTE",bandialog):SetValue(tExp["min"])
		else
			-- Maybe we got the settings: add the default tempban time to the current date (if not then 0)
			local iBanTime = tCtrls["num"]["num_16"]:GetValue()*60
			local tExp = os.date("*t",os.time()+iBanTime)
			tFuncs.GetCtrl("ID_NUM_BANDAY",bandialog):SetValue(tExp["day"])
			tFuncs.GetCtrl("ID_NUM_BANMONTH",bandialog):SetSelection(tExp["month"]-1)
			tFuncs.GetCtrl("ID_NUM_BANYEAR",bandialog):SetValue(tExp["year"])
			tFuncs.GetCtrl("ID_NUM_BANHOUR",bandialog):SetValue(tExp["hour"])
			tFuncs.GetCtrl("ID_NUM_BANMINUTE",bandialog):SetValue(tExp["min"])
		end
		tFuncs.GetCtrl("wxID_OK",bandialog):Connect(wx.wxEVT_COMMAND_BUTTON_CLICKED,function(event)
			if not tHubData.bEntered then
				wx.wxMessageBox(tLang.NoConnectionToHub,_APPNAME,wx.wxICON_ERROR)
				return
			end
			-- Checking
			local bNickban = tFuncs.GetCtrl("ID_CHK_NICKBAN",bandialog):GetValue()
			local bIPban = tFuncs.GetCtrl("ID_CHK_IPBAN",bandialog):GetValue()
			local bFullban = tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):GetValue()
			local bPermban = tFuncs.GetCtrl("ID_CHK_BANPERMANENT",bandialog):GetValue()
			local bTempban = tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):GetValue()
			local sIP = tFuncs.GetCtrl("ID_TXT_BANIP",bandialog):GetValue()
			local sNick = tFuncs.GetCtrl("ID_TXT_BANNICK",bandialog):GetValue()
			local sReason = tFuncs.GetCtrl("ID_TXT_BANREASON",bandialog):GetValue()
			local sCreatedBy = tFuncs.GetCtrl("ID_TXT_BANCREATEDBY",bandialog):GetValue()
			local tExp = {}
			if bTempban then
				tExp["day"] = tFuncs.GetCtrl("ID_NUM_BANDAY",bandialog):GetValue()
				tExp["month"] = tFuncs.GetCtrl("ID_NUM_BANMONTH",bandialog):GetSelection()+1
				tExp["year"] = tFuncs.GetCtrl("ID_NUM_BANYEAR",bandialog):GetValue()
				tExp["hour"] = tFuncs.GetCtrl("ID_NUM_BANHOUR",bandialog):GetValue()
				tExp["min"] = tFuncs.GetCtrl("ID_NUM_BANMINUTE",bandialog):GetValue()
				if os.time(tExp) < os.time() then
					wx.wxMessageBox(tLang.BadTimeSpecifiedBanExpired,_APPNAME,wx.wxICON_EXCLAMATION)
					return
				end
			end
			if not bNickban and not bIPban then
				wx.wxMessageBox(tLang.YouCantCreateBanWithoutNickOrIP,_APPNAME,wx.wxICON_EXCLAMATION)
				return
			end
			if bIPban then
				if sIP == "" then
					wx.wxMessageBox(tLang.ForIPBanSpecifyIP,_APPNAME,wx.wxICON_EXCLAMATION)
					return
				elseif not tFuncs.IsIP(sIP) then
					wx.wxMessageBox(sIP.." "..tLang.IsNotValidIPAddress,_APPNAME,wx.wxICON_EXCLAMATION)
					return
				end
			end
			if bNickban then
				if sNick == "" then
					wx.wxMessageBox(tLang.ForNickBanSpecifyNick,_APPNAME,wx.wxICON_EXCLAMATION)
					return
				end
			end
			if not t then
				for i,v in ipairs(tHubData.tBans) do
					if (bIPban and v[1] == sIP) or (bNickban and v[2] == sNick) then
						wx.wxMessageBox(tLang.SimilarBanExist,_APPNAME,wx.wxICON_EXCLAMATION)
						return
					end
				end
			end
			event:Skip()
		end)
		bandialog:Centre()
		if bandialog:ShowModal() == wx.wxID_OK then
			local bNickban = tFuncs.GetCtrl("ID_CHK_NICKBAN",bandialog):GetValue()
			local bIPban = tFuncs.GetCtrl("ID_CHK_IPBAN",bandialog):GetValue()
			local bFullban = tFuncs.GetCtrl("ID_CHK_FULLBAN",bandialog):GetValue()
			local bTempban = tFuncs.GetCtrl("ID_CHK_BANTEMPORARY",bandialog):GetValue()
			local sIP = tFuncs.GetCtrl("ID_TXT_BANIP",bandialog):GetValue()
			local sNick = tFuncs.GetCtrl("ID_TXT_BANNICK",bandialog):GetValue()
			local sReason = tFuncs.GetCtrl("ID_TXT_BANREASON",bandialog):GetValue():gsub("\"","\\\"")
			local sCreatedBy = tFuncs.GetCtrl("ID_TXT_BANCREATEDBY",bandialog):GetValue():gsub("\"","\\\"")
			local tExp = {}
			tExp["day"] = tFuncs.GetCtrl("ID_NUM_BANDAY",bandialog):GetValue()
			tExp["month"] = tFuncs.GetCtrl("ID_NUM_BANMONTH",bandialog):GetSelection()+1
			tExp["year"] = tFuncs.GetCtrl("ID_NUM_BANYEAR",bandialog):GetValue()
			tExp["hour"] = tFuncs.GetCtrl("ID_NUM_BANHOUR",bandialog):GetValue()
			tExp["min"] = tFuncs.GetCtrl("ID_NUM_BANMINUTE",bandialog):GetValue()
			return {{t or ""},{bIPban,bFullban,bNickban,sIP,sNick,sReason,sCreatedBy,(bTempban and os.time(tExp) or 0)}}
		end
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end,

RangeBan = function(t)
	local rangebandialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(rangebandialog,wx.NULL,"ID_DLG_RANGEBANS") then
		-- Translations --
		rangebandialog:SetTitle(tLang.RangeBans)
		tFuncs.GetCtrl("ID_STT_RANGEBANRANGE",rangebandialog):SetLabel(tLang.Range)
		tFuncs.GetCtrl("ID_CHK_RANGEFULLBAN",rangebandialog):SetLabel(tLang.FullBan)
		tFuncs.GetCtrl("ID_CHK_RANGEFULLBAN",rangebandialog):SetToolTip(tLang.FullBanDisallowAll)
		tFuncs.GetCtrl("ID_STT_RANGEBANREASON",rangebandialog):SetLabel(tLang.Reason)
		tFuncs.GetCtrl("ID_STT_RANGEBANCREATEDBY",rangebandialog):SetLabel(tLang.BannedBy)
		tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):SetLabel(tLang.Temporary)
		local tMonths = {}
		for i = 1,12 do
			table.insert(tMonths,os.date("%b",os.time({year = 2010, month = i, day = 1})))
		end
		
		tFuncs.GetCtrl("ID_NUM_RANGEBANMONTH",rangebandialog):Clear(); tFuncs.GetCtrl("ID_NUM_RANGEBANMONTH",rangebandialog):Append(tMonths)
		tFuncs.GetCtrl("ID_CHK_RANGEBANPERMANENT",rangebandialog):SetLabel(tLang.Permanent)
		tFuncs.GetCtrl("wxID_OK",rangebandialog):SetLabel(tLang.Accept)
		tFuncs.GetCtrl("wxID_CANCEL",rangebandialog):SetLabel(tLang.Discard)
		-- Translations end --
		tFuncs.GetCtrl("ID_TXT_RANGEBANFROMIP",rangebandialog):SetValidator(tValidators.IPv4)
		tFuncs.GetCtrl("ID_TXT_RANGEBANTOIP",rangebandialog):SetValidator(tValidators.IPv4)
		tFuncs.GetCtrl("ID_TXT_RANGEBANREASON",rangebandialog):SetValidator(tValidators.NoPipe)
		tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):Connect(wx.wxEVT_COMMAND_CHECKBOX_CLICKED,function(event)
			if event:IsChecked() == true then tFuncs.GetCtrl("ID_CHK_RANGEBANPERMANENT",rangebandialog):SetValue(false)
			else tFuncs.GetCtrl("ID_CHK_RANGEBANPERMANENT",rangebandialog):SetValue(true)
			end
		end)
		tFuncs.GetCtrl("ID_CHK_RANGEBANPERMANENT",rangebandialog):Connect(wx.wxEVT_COMMAND_CHECKBOX_CLICKED,function(event)
			if event:IsChecked() == true then tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):SetValue(false)
			else tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):SetValue(true)
			end
		end)
		if t and #t == 5 then
			local sFromIP,sToIP = t[1]:match("(%S+)%s%-%s(%S+)")
			if not sFromIP then return end
			tFuncs.GetCtrl("ID_TXT_RANGEBANFROMIP",rangebandialog):SetValue(sFromIP)
			tFuncs.GetCtrl("ID_TXT_RANGEBANTOIP",rangebandialog):SetValue(sToIP)
			tFuncs.GetCtrl("ID_CHK_RANGEFULLBAN",rangebandialog):SetValue(t[5] == "1")
			tFuncs.GetCtrl("ID_TXT_RANGEBANREASON",rangebandialog):SetValue(t[3])
			tFuncs.GetCtrl("ID_TXT_RANGEBANCREATEDBY",rangebandialog):SetValue(t[2])
			tFuncs.GetCtrl("ID_CHK_RANGEBANPERMANENT",rangebandialog):SetValue(#t[4] == 0)
			tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):SetValue(#t[4] > 0)
			local tExp = os.date("*t",(tonumber(t[4]) or os.time()))
			tFuncs.GetCtrl("ID_NUM_RANGEBANDAY",rangebandialog):SetValue(tExp["day"])
			tFuncs.GetCtrl("ID_NUM_RANGEBANMONTH",rangebandialog):SetSelection(tExp["month"]-1)
			tFuncs.GetCtrl("ID_NUM_RANGEBANYEAR",rangebandialog):SetValue(tExp["year"])
			tFuncs.GetCtrl("ID_NUM_RANGEBANHOUR",rangebandialog):SetValue(tExp["hour"])
			tFuncs.GetCtrl("ID_NUM_RANGEBANMINUTE",rangebandialog):SetValue(tExp["min"])
		else
			-- Maybe we got the settings: add the default tempban time to the current date (if not then 0)
			local iBanTime = tCtrls["num"]["num_16"]:GetValue()*60
			local tExp = os.date("*t",os.time()+iBanTime)
			tFuncs.GetCtrl("ID_NUM_RANGEBANDAY",rangebandialog):SetValue(tExp["day"])
			tFuncs.GetCtrl("ID_NUM_RANGEBANMONTH",rangebandialog):SetSelection(tExp["month"]-1)
			tFuncs.GetCtrl("ID_NUM_RANGEBANYEAR",rangebandialog):SetValue(tExp["year"])
			tFuncs.GetCtrl("ID_NUM_RANGEBANHOUR",rangebandialog):SetValue(tExp["hour"])
			tFuncs.GetCtrl("ID_NUM_RANGEBANMINUTE",rangebandialog):SetValue(tExp["min"])
		end
		tFuncs.GetCtrl("wxID_OK",rangebandialog):Connect(wx.wxEVT_COMMAND_BUTTON_CLICKED,function(event)
			if not tHubData.bEntered then
				wx.wxMessageBox(tLang.NoConnectionToHub,_APPNAME,wx.wxICON_ERROR)
				return
			end
			-- Checking
			local bFullban = tFuncs.GetCtrl("ID_CHK_RANGEFULLBAN",rangebandialog):GetValue()
			local bPermban = tFuncs.GetCtrl("ID_CHK_RANGEBANPERMANENT",rangebandialog):GetValue()
			local bTempban = tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):GetValue()
			local sFromIP = tFuncs.GetCtrl("ID_TXT_RANGEBANFROMIP",rangebandialog):GetValue()
			local sToIP = tFuncs.GetCtrl("ID_TXT_RANGEBANTOIP",rangebandialog):GetValue()
			local sReason = tFuncs.GetCtrl("ID_TXT_RANGEBANREASON",rangebandialog):GetValue()
			local sCreatedBy = tFuncs.GetCtrl("ID_TXT_RANGEBANCREATEDBY",rangebandialog):GetValue()
			local tExp = {}
			if bTempban then
				tExp["day"] = tFuncs.GetCtrl("ID_NUM_RANGEBANDAY",rangebandialog):GetValue()
				tExp["month"] = tFuncs.GetCtrl("ID_NUM_RANGEBANMONTH",rangebandialog):GetSelection()+1
				tExp["year"] = tFuncs.GetCtrl("ID_NUM_RANGEBANYEAR",rangebandialog):GetValue()
				tExp["hour"] = tFuncs.GetCtrl("ID_NUM_RANGEBANHOUR",rangebandialog):GetValue()
				tExp["min"] = tFuncs.GetCtrl("ID_NUM_RANGEBANMINUTE",rangebandialog):GetValue()
				if os.time(tExp) < os.time() then
					wx.wxMessageBox(tLang.BadTimeSpecifiedBanExpired,_APPNAME,wx.wxICON_EXCLAMATION)
					return
				end
			end
			if sFromIP == "" or sToIP == "" then
				wx.wxMessageBox(tLang.NoValidIpRangeSpecified,_APPNAME,wx.wxICON_EXCLAMATION)
				return
			elseif not tFuncs.IsIP(sFromIP) then
				wx.wxMessageBox(sFromIP.." "..tLang.IsNotValidIPAddress,_APPNAME,wx.wxICON_EXCLAMATION)
				return
			elseif not tFuncs.IsIP(sToIP) then
				wx.wxMessageBox(sToIP.." "..tLang.IsNotValidIPAddress,_APPNAME,wx.wxICON_EXCLAMATION)
				return
			elseif tFuncs.IP2DEC(sToIP) < tFuncs.IP2DEC(sFromIP) then
				wx.wxMessageBox(tLang.NoValidIpRangeSpecified,_APPNAME,wx.wxICON_EXCLAMATION)
				return
			end
			if not t then
				-- Check ranges inside? Px doesn't do it, but it would be easy with tFuncs.IP2DEC
				for i,v in ipairs(tHubData.tRangeBans) do
					if v[1] == sFromIP.." - "..sToIP then
						wx.wxMessageBox(tLang.SimilarBanExist,_APPNAME,wx.wxICON_EXCLAMATION)
						return
					end
				end
			end
			event:Skip()
		end)
		rangebandialog:Centre()
		if rangebandialog:ShowModal() == wx.wxID_OK then
			local bFullban = tFuncs.GetCtrl("ID_CHK_RANGEFULLBAN",rangebandialog):GetValue()
			local bTempban = tFuncs.GetCtrl("ID_CHK_RANGEBANTEMPORARY",rangebandialog):GetValue()
			local sFromIP = tFuncs.GetCtrl("ID_TXT_RANGEBANFROMIP",rangebandialog):GetValue()
			local sToIP = tFuncs.GetCtrl("ID_TXT_RANGEBANTOIP",rangebandialog):GetValue()
			local sReason = tFuncs.GetCtrl("ID_TXT_RANGEBANREASON",rangebandialog):GetValue():gsub("\"","\\\"")
			local sCreatedBy = tFuncs.GetCtrl("ID_TXT_RANGEBANCREATEDBY",rangebandialog):GetValue():gsub("\"","\\\"")
			local tExp = {}
			tExp["day"] = tFuncs.GetCtrl("ID_NUM_RANGEBANDAY",rangebandialog):GetValue()
			tExp["month"] = tFuncs.GetCtrl("ID_NUM_RANGEBANMONTH",rangebandialog):GetSelection()+1
			tExp["year"] = tFuncs.GetCtrl("ID_NUM_RANGEBANYEAR",rangebandialog):GetValue()
			tExp["hour"] = tFuncs.GetCtrl("ID_NUM_RANGEBANHOUR",rangebandialog):GetValue()
			tExp["min"] = tFuncs.GetCtrl("ID_NUM_RANGEBANMINUTE",rangebandialog):GetValue()
			return {{t},{sFromIP,sToIP,bFullban,sReason,sCreatedBy,(bTempban and os.time(tExp) or 0)}}
		end
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end,

Settings = function()
	local tSettingsTable = {DefaultNick = "txt_login_nick", DefaultDesc = "txt_login_desc", DefaultEmail = "txt_login_email",
		DefaultShare = "txt_login_share", AdvancedEditor = "chk_advanced_editor",LastState = "chk_last_state",
		Reconnect = "chk_reconnect", TrayIcon = "chk_tray_icon", MinToTray = "chk_min_to_tray",
		DoubleClickDownload = "chk_dclick_download", UDPDebugPort = "txt_debug_port",
		UDPLog_SYS = "CHK_UDPSYS",UDPLog_ERR = "CHK_UDPERR", UDPLog_LUA = "CHK_UDPLUA",UDPLog_REG = "CHK_UDPREG",
		UDPLog_LOG = "CHK_UDPLOG"}

	local settingsdialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(settingsdialog,wx.NULL,"ID_DLG_SETTINGS") then
		settingsdialog:SetTitle(tLang.Settings)
		tFuncs.GetCtrl("txt_login_nick",settingsdialog):SetValidator(tValidators.Nick)
		tFuncs.GetCtrl("txt_login_desc",settingsdialog):SetValidator(tValidators.NoPipeDollar)
		tFuncs.GetCtrl("txt_login_share",settingsdialog):SetValidator(tValidators.Numbers)
		
		tCtrls["stt_sharesize"]				= tFuncs.GetCtrl("stt_sharesize",settingsdialog)
		tCtrls["txt_login_share"]			= tFuncs.GetCtrl("txt_login_share",settingsdialog)
		
		tFuncs.GetCtrl("stb_login",settingsdialog):SetLabel(tLang.Conection)
		tFuncs.GetCtrl("stt_login_nick",settingsdialog):SetLabel(tLang.Nick)
		tFuncs.GetCtrl("stt_login_desc",settingsdialog):SetLabel(tLang.Description)
		tFuncs.GetCtrl("stt_login_email",settingsdialog):SetLabel(tLang.Email)
		tFuncs.GetCtrl("stt_login_share",settingsdialog):SetLabel(tLang.ShareSize)
		tFuncs.GetCtrl("stb_program_settings",settingsdialog):SetLabel(tLang.ProgramSettings)
		tFuncs.GetCtrl("chk_tray_icon",settingsdialog):SetLabel(tLang.TrayIcon)
		tFuncs.GetCtrl("chk_min_to_tray",settingsdialog):SetLabel(tLang.MinimizeToTray)
		tFuncs.GetCtrl("chk_advanced_editor",settingsdialog):SetLabel(tLang.UseAdvancedScriptEditor)
		tFuncs.GetCtrl("chk_reconnect",settingsdialog):SetLabel(tLang.ReconnectWhenConnectionLost)
		tFuncs.GetCtrl("chk_last_state",settingsdialog):SetLabel(tLang.RememberConnectionState)
		tFuncs.GetCtrl("chk_dclick_download",settingsdialog):SetLabel(tLang.DoubleClickOpenScript)
		tFuncs.GetCtrl("stb_udp_debug",settingsdialog):SetLabel(tLang.UDPDebugger)
		tFuncs.GetCtrl("stt_debug_port",settingsdialog):SetLabel(tLang.UDPDebuggerPort)
		tFuncs.GetCtrl("stb_language",settingsdialog):SetLabel(tLang.Language)
		tFuncs.GetCtrl("wxID_OK",settingsdialog):SetLabel(tLang.Accept)
		tFuncs.GetCtrl("wxID_CANCEL",settingsdialog):SetLabel(tLang.Discard)
		for i,v in ipairs({"SYS","ERR","LUA","REG","LOG"}) do
			tFuncs.GetCtrl("CHK_UDP"..v,settingsdialog):SetLabel(tLang.SaveFormatMessagesToLog:format(v))
		end
		
		local old_lang, langs, langs_count, cur_lang = tCfg.Language, {}, 0, 0
		for file in lfs.dir(_path.."language/") do
			if file:sub(-4, -1):lower() == ".tbl" then
				local lang = file:sub(1, -5)
				table.insert(langs, lang)
				if tCfg.Language:lower() == lang:lower() then
					cur_lang = langs_count
				end
				tFuncs.GetCtrl("wxID_LANGUAGE",settingsdialog):Append(lang)
				langs_count = langs_count+1
			end
		end
		tFuncs.GetCtrl("wxID_LANGUAGE",settingsdialog):SetSelection(cur_lang)

		settingsdialog:Connect(tCtrls["xmlDialogs"].GetXRCID("txt_login_share"),wx.wxEVT_COMMAND_TEXT_UPDATED,function(event)
			if tCtrls["txt_login_share"]:GetValue() == "" then
				tCtrls["txt_login_share"]:SetValue("0")
			end
			tCtrls["stt_sharesize"]:SetLabel(tFuncs.ConvertShare(tonumber(tCtrls["txt_login_share"]:GetValue())))
		end)
		tFuncs.GetCtrl("wxID_OK",settingsdialog):Connect(wx.wxEVT_COMMAND_BUTTON_CLICKED,
			function(event)
				if tFuncs.GetCtrl("txt_login_nick",settingsdialog):GetValue() == "" then
					wx.wxMessageBox(tLang.NoNickSpecified,tLang.Error)
				else
					tCfg.Language = langs[tFuncs.GetCtrl("wxID_LANGUAGE",settingsdialog):GetSelection()+1]
					if tCfg.TrayIcon ~= tFuncs.GetCtrl("chk_tray_icon",settingsdialog):GetValue() or tCfg.AdvancedEditor ~= tFuncs.GetCtrl("chk_advanced_editor",settingsdialog):GetValue() or tCfg.Language ~= old_lang then
						wx.wxMessageBox(tLang.NeedRestartToApply,tLang.Attention)
					end
					for i,v in pairs(tSettingsTable) do
						tCfg[i] = tFuncs.GetCtrl(v,settingsdialog):GetValue()
					end
					SaveCfg()
					settingsdialog:Close()
				end
			end)
		settingsdialog:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_CHECKBOX_CLICKED,
			function(event)
				local evtid = event:GetId()
				for i,v in pairs(tHubSettings) do
					if v[2] and evtid == tCtrls["xmlDialogs"].GetXRCID(v[2]) then
						if event:IsChecked() then
							tFuncs.GetCtrl(v[1],settingsdialog):Enable(true)
						else
							tFuncs.GetCtrl(v[1],settingsdialog):Enable(false)
						end
					end
				end
			end)
			for i,v in pairs(tSettingsTable) do
				if tCfg[i] then
					tFuncs.GetCtrl(v,settingsdialog):SetValue(tCfg[i])
				end
			end
		settingsdialog:Centre()
		settingsdialog:ShowModal()
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end,

HubSettings = function(hub_num)
	local hubsetdialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(hubsetdialog,wx.NULL,"ID_DLG_HUBSET") then
		hubsetdialog:SetTitle(tLang.HubSettings)
		tFuncs.GetCtrl("txt_login_address",hubsetdialog):SetValidator(tValidators.NoPipeDollar)
		tFuncs.GetCtrl("txt_login_address",hubsetdialog):Connect(wx.wxEVT_COMMAND_TEXT_ENTER ,function(event) tFuncs.Connect() end)
		tFuncs.GetCtrl("txt_login_nick",hubsetdialog):SetValidator(tValidators.Nick)
		tFuncs.GetCtrl("txt_login_desc",hubsetdialog):SetValidator(tValidators.NoPipeDollar)
		tFuncs.GetCtrl("txt_login_tag",hubsetdialog):SetValidator(tValidators.NoPipeDollar)
		tFuncs.GetCtrl("txt_login_share",hubsetdialog):SetValidator(tValidators.Numbers)
		
		tCtrls["stt_sharesize"]				= tFuncs.GetCtrl("stt_sharesize",hubsetdialog)
		tCtrls["txt_login_share"]			= tFuncs.GetCtrl("txt_login_share",hubsetdialog)
		
		tFuncs.GetCtrl("stt_hub_name",hubsetdialog):SetLabel(tLang.HubName)
		tFuncs.GetCtrl("stt_login_address",hubsetdialog):SetLabel(tLang.HubAddress)
		tFuncs.GetCtrl("stt_login_nick",hubsetdialog):SetLabel(tLang.Nick)
		tFuncs.GetCtrl("stt_login_passwd",hubsetdialog):SetLabel(tLang.Password)
		tFuncs.GetCtrl("stt_login_desc",hubsetdialog):SetLabel(tLang.Description)
		tFuncs.GetCtrl("stt_login_tag",hubsetdialog):SetLabel(tLang.Tag)
		tFuncs.GetCtrl("stt_login_email",hubsetdialog):SetLabel(tLang.Email)
		tFuncs.GetCtrl("stt_login_share",hubsetdialog):SetLabel(tLang.ShareSize)
		tFuncs.GetCtrl("wxID_OK",hubsetdialog):SetLabel(tLang.Accept)
		tFuncs.GetCtrl("wxID_CANCEL",hubsetdialog):SetLabel(tLang.Discard)
		
		hubsetdialog:Connect(tCtrls["xmlDialogs"].GetXRCID("txt_login_share"),wx.wxEVT_COMMAND_TEXT_UPDATED,function(event)
			if tCtrls["txt_login_share"]:GetValue() == "" then
				tCtrls["txt_login_share"]:SetValue("0")
			end
			tCtrls["stt_sharesize"]:SetLabel(tFuncs.ConvertShare(tonumber(tCtrls["txt_login_share"]:GetValue())))
		end)
		tFuncs.GetCtrl("wxID_OK",hubsetdialog):Connect(wx.wxEVT_COMMAND_BUTTON_CLICKED,
			function(event)
				if tFuncs.GetCtrl("txt_hub_name",hubsetdialog):GetValue() == "" then
					wx.wxMessageBox(tLang.NoHubNameSpecified,tLang.Error)
				elseif tFuncs.GetCtrl("txt_login_address",hubsetdialog):GetValue() == "" then
					wx.wxMessageBox(tLang.NoHubAddressSpecified,tLang.Error)
				else
					local number = hub_num or #tHubs+1
					tHubs[number] = {}
					for i,v in pairs(tHubSettings) do
						if not v[2] or tFuncs.GetCtrl(v[2],hubsetdialog):GetValue() then
							tHubs[number][i] = tFuncs.GetCtrl(v[1],hubsetdialog):GetValue()
							if v[3] and tHubs[number][i] == "" then
								tHubs[number][i] = nil
							end
						end
					end
					if hub_num then
						tCtrls["hub_select"]:SetString(number-1,tHubs[number].Name)
					else
						tCtrls["hub_select"]:Append(tHubs[number].Name)
					end
					tCtrls["hub_select"]:SetSelection(number-1)
					SaveHubs()
					hubsetdialog:Close()
				end
			end)
		hubsetdialog:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_CHECKBOX_CLICKED,
			function(event)
				local evtid = event:GetId()
				for i,v in pairs(tHubSettings) do
					if v[2] and evtid == tCtrls["xmlDialogs"].GetXRCID(v[2]) then
						if event:IsChecked() then
							tFuncs.GetCtrl(v[1],hubsetdialog):Enable(true)
						else
							tFuncs.GetCtrl(v[1],hubsetdialog):Enable(false)
						end
					end
				end
			end)
		if hub_num then
			for i,v in pairs(tHubSettings) do
				if tHubs[hub_num][i] then
					if v[2] then
						tFuncs.GetCtrl(v[2],hubsetdialog):SetValue(true)
					end
					tFuncs.GetCtrl(v[1],hubsetdialog):SetValue(tHubs[hub_num][i])
				elseif v[2] then
					tFuncs.GetCtrl(v[1],hubsetdialog):Enable(false)
				end
			end
			if tHubs[hub_num].Share then 
				tCtrls["stt_sharesize"]:SetLabel(tFuncs.ConvertShare(tonumber(tHubs[hub_num].Share)))
			end
		else
			for i,v in pairs(tHubSettings) do
				if v[2] then
					tFuncs.GetCtrl(v[1],hubsetdialog):Enable(false)
				end
			end
		end
		hubsetdialog:Centre()
		hubsetdialog:ShowModal()
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_EXCLAMATION)
	end
end,

Memory = function()
	local dialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(dialog,wx.NULL,"ID_DLG_MEMORY") then
		dialog:SetTitle(tLang.ScriptsMemUsage)
		dialog:SetSize(wx.wxSize(tCfg.MUWidth or 250,tCfg.MUHeight or 400))
		local list = tFuncs.GetCtrl("wxID_MEM_LIST",dialog)
		list:InsertColumn(0,tLang.Scripting,wx.wxLIST_FORMAT_LEFT,tCfg.MUCol_1 or 110)
		list:InsertColumn(1,tLang.MemUsage,wx.wxLIST_FORMAT_RIGHT,tCfg.MUCol_2 or 110)
		if tCtrls["mem_table"] then
			for i,v in ipairs(tCtrls["mem_table"]) do
				local item = list:InsertItem(list:GetItemCount(),v[1])
				list:SetItem(item,1,v[2])
			end
		end
		dialog:Connect(wx.wxID_ANY,wx.wxEVT_CLOSE_WINDOW,
			function(event)
				tCfg.MUWidth,tCfg.MUHeight = dialog:GetSizeWH()
				tCfg.MUCol_1,tCfg.MUCol_2 = list:GetColumnWidth(0),list:GetColumnWidth(1)
				event:Skip()
			end)
		dialog:Centre()
		dialog:ShowModal()
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end,

GeneratePassword = function()
	local pwddialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(pwddialog,wx.NULL,"ID_DLG_PWGEN") then
		pwddialog:SetTitle(tLang.PwGenerator)
		tFuncs.GetCtrl("ID_CHK_PWGENSMALL",pwddialog):SetLabel(tLang.PwLower)
		tFuncs.GetCtrl("ID_CHK_PWGENBIG",pwddialog):SetLabel(tLang.PwUpper)
		tFuncs.GetCtrl("ID_CHK_PWGENNUMBER",pwddialog):SetLabel(tLang.PwDigits)
		tFuncs.GetCtrl("ID_CHK_PWGENSPECIAL",pwddialog):SetLabel(tLang.PwSpecial)
		tFuncs.GetCtrl("ID_CMD_PWGENGENERATE",pwddialog):SetLabel(tLang.PwGenerate)
		math.randomseed(os.time())
		local GenPass = function()
			local tChars, sPass = {}, ""
			if tFuncs.GetCtrl("ID_CHK_PWGENSMALL",pwddialog):IsChecked() then table.insert(tChars,{97,122}) end
			if tFuncs.GetCtrl("ID_CHK_PWGENBIG",pwddialog):IsChecked() then table.insert(tChars,{65, 90 }) end
			if tFuncs.GetCtrl("ID_CHK_PWGENNUMBER",pwddialog):IsChecked() then table.insert(tChars,{48, 57 }) end
			if tFuncs.GetCtrl("ID_CHK_PWGENSPECIAL",pwddialog):IsChecked() then table.insert(tChars,{{33,47},{58,64}}) end
			if #tChars < 1 then return "" end
			for i=1,tFuncs.GetCtrl("ID_NUM_PWGENLENGTH",pwddialog):GetValue() do
				local j = math.random(#tChars)
				local iFirst,iSecond = tChars[j][1],tChars[j][2]
				if type(iFirst) == "table" then
					local iGroup = math.random(2)
					iFirst,iSecond = tChars[j][iGroup][1],tChars[j][iGroup][2]
				end
				sPass = sPass..string.char(math.random(iFirst,iSecond))
			end
			return sPass
		end
		if type(tCfg.PwGenLower) ~= "nil" then
			tFuncs.GetCtrl("ID_CHK_PWGENSMALL",pwddialog):SetValue(tCfg.PwGenLower)
		end
		if type(tCfg.PwGenUpper) ~= "nil" then
			tFuncs.GetCtrl("ID_CHK_PWGENBIG",pwddialog):SetValue(tCfg.PwGenUpper)
		end
		if type(tCfg.PwGenDigit) ~= "nil" then
			tFuncs.GetCtrl("ID_CHK_PWGENNUMBER",pwddialog):SetValue(tCfg.PwGenDigit)
		end
		if type(tCfg.PwGenSpecial) ~= "nil" then
			tFuncs.GetCtrl("ID_CHK_PWGENSPECIAL",pwddialog):SetValue(tCfg.PwGenSpecial)
		end
		if tCfg.PwGenLength then
			tFuncs.GetCtrl("ID_NUM_PWGENLENGTH",pwddialog):SetValue(tCfg.PwGenLength)
		end

		local Save = function()
			tCfg.PwGenLower = tFuncs.GetCtrl("ID_CHK_PWGENSMALL",pwddialog):IsChecked()
			tCfg.PwGenUpper = tFuncs.GetCtrl("ID_CHK_PWGENBIG",pwddialog):IsChecked()
			tCfg.PwGenDigit = tFuncs.GetCtrl("ID_CHK_PWGENNUMBER",pwddialog):IsChecked()
			tCfg.PwGenSpecial = tFuncs.GetCtrl("ID_CHK_PWGENSPECIAL",pwddialog):IsChecked()
			tCfg.PwGenLength = tFuncs.GetCtrl("ID_NUM_PWGENLENGTH",pwddialog):GetValue()
		end
		pwddialog:Connect(tCtrls["ID_CMD_PWGENGENERATE"],wx.wxEVT_COMMAND_BUTTON_CLICKED,function(event)
			tFuncs.GetCtrl("ID_TXT_PWGENPASSWORD",pwddialog):SetValue(GenPass())
		end)
		local ret = pwddialog:ShowModal()
		Save()
		if ret == wx.wxID_OK then
			return tFuncs.GetCtrl("ID_TXT_PWGENPASSWORD",pwddialog):GetValue()
		end
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end,

RegUser = function(sNick,sPassword,sProfileName)
	local regdialog = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(regdialog,wx.NULL,"ID_DLG_REGUSER") then
		-- Translations --
		regdialog:SetTitle(tLang.RegisteredUser)
		tFuncs.GetCtrl("ID_STT_REGNICK",regdialog):SetLabel(tLang.Nick)
		tFuncs.GetCtrl("ID_STT_REGPASSWORD",regdialog):SetLabel(sNick and sPassword and #sPassword == 0 and tLang.NewPassword or tLang.Password)
		tFuncs.GetCtrl("ID_STT_REGPROFILE",regdialog):SetLabel(tLang.Profile)
		tFuncs.GetCtrl("wxID_OK",regdialog):SetLabel(tLang.Accept)
		tFuncs.GetCtrl("wxID_CANCEL",regdialog):SetLabel(tLang.Discard)
		-- Translations end --
		tFuncs.GetCtrl("ID_TXT_REGNICK",regdialog):SetValidator(tValidators.Nick)
		tFuncs.GetCtrl("ID_TXT_REGPASSWORD",regdialog):SetValidator(tValidators.Password)
		if sNick then
			tFuncs.GetCtrl("ID_TXT_REGNICK",regdialog):SetValue(sNick)
			tFuncs.GetCtrl("ID_TXT_REGNICK",regdialog):Enable(false)
			tFuncs.GetCtrl("ID_TXT_REGPASSWORD",regdialog):SetValue(sPassword)
		end
		regdialog:Connect(tCtrls["ID_CMD_REGPWDGEN"],wx.wxEVT_COMMAND_BUTTON_CLICKED,function(event)
			local pass = tDialogs.GeneratePassword()
			if pass and #pass > 0 then
				tFuncs.GetCtrl("ID_TXT_REGPASSWORD",regdialog):SetValue(pass)
			end
		end)
		local tProfiles = {}
		local iprofile = #tHubData.tProfiles
		if #tHubData.tProfiles > 0 then -- If user has no permission, didn't get the profiles.
			for i=0,#tHubData.tProfiles do
			    table.insert(tProfiles,tHubData.tProfiles[i][1])
				if sProfileName and sProfileName == tHubData.tProfiles[i][1] then
					iprofile = i
				end
			end
		end
		tFuncs.GetCtrl("ID_NUM_REGPROFILE",regdialog):Append(tProfiles)
		tFuncs.GetCtrl("ID_NUM_REGPROFILE",regdialog):SetSelection(iprofile)
		regdialog:Connect(tCtrls["wxID_OK"],wx.wxEVT_COMMAND_BUTTON_CLICKED,function(event)
			if not tHubData.bEntered then
				wx.wxMessageBox(tLang.NoConnectionToHub,_APPNAME,wx.wxICON_ERROR)
			elseif #tFuncs.GetCtrl("ID_TXT_REGNICK",regdialog):GetValue() == 0 then
				wx.wxMessageBox(tLang.NickMustBeSpecified,_APPNAME,wx.wxICON_EXCLAMATION)
			elseif not sNick and #tFuncs.GetCtrl("ID_TXT_REGPASSWORD",regdialog):GetValue() == 0 then
				wx.wxMessageBox(tLang.PassMustBeSpecified,_APPNAME,wx.wxICON_EXCLAMATION)
			else
				event:Skip()
			end
		end)
		if regdialog:ShowModal() == wx.wxID_OK then
			if sNick and sNick:lower() == tData.CurrentHub.Nick:lower() and wx.wxMessageBox(tLang.ChangeSelfAccountMsg,tLang.Attention,wx.wxICON_EXCLAMATION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxNO then
				return
			end
		    return tFuncs.GetCtrl("ID_TXT_REGNICK",regdialog):GetValue(),tFuncs.GetCtrl("ID_TXT_REGPASSWORD",regdialog):GetValue(),tFuncs.GetCtrl("ID_NUM_REGPROFILE",regdialog):GetSelection()
		end
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end,

About = function()
	local about = wx.wxDialog()
	if tCtrls["xmlDialogs"]:LoadDialog(about,wx.NULL,"ID_DLG_ABOUT") then
		tFuncs.GetCtrl("ID_HTMLWINDOW",about):SetPage( 
[[<html>
	<head>
		<meta http-equiv="content-type" content="text/html; charset=]]..tLang.AboutCharset..[[" />
	</head>
	<body>
		<center><table cellspacing = 4 cellpadding = 4>
			<tr>
				<td align="right"><img src="]].._path..[[resources/logo.jpg"></td>
				<td><font size = "20"><b>]].._APPNAME.." ".._APPVER..[[</b></font><center><b>Ptokax Administration Tool</b></center></td>
			</tr>
		</table>
		<br><br> 2009-]]..os.date("%Y")..[[ alex82<br><br>]]..tLang.BasedOn..[[ <b>PtokaX Remote Administration</b> v2.12 <i>by Hungarista</i><br>
		<br>]]..tLang.ComponentsAndCodeParts..[[:<br>
		<b>]].._VERSION..[[<br>]]..wxlua.wxLUA_VERSION_STRING..[[<br>LuaSocket<br>Editor.wx.lua</b><br><br>]]..
		(rawget(tLang,"TranslationAuthor") and tLang.Translation..": <b>"..tLang.TranslationAuthor.."</b>" or "")..[[<br><br><br><br>
		<img src="]].._path..[[resources/mydc.jpg">
		</center>
	</body>
</html>
]])
		about:SetTitle(tLang.About)
		about:Centre()
		about:ShowModal()
		about:Destroy()
	else
		wx.wxMessageBox(tLang.ErrorLoadingDialog,_APPNAME,wx.wxICON_ERROR)
	end
end

}