--[[##################################################################################

	PXControl by alex82
	Based on Ptokax Remote Administration by Hungarista

####################################################################################

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

###################################################################################]]

tFuncs = {}

tFuncs.GetCtrl = function(sid,owner)
	if not owner then owner = tCtrls["app"] end
	local ctrl = owner:FindWindow(tCtrls["xmlResource"].GetXRCID(sid))
	if sid:sub(1,4) ~= "chk_" and not ctrl then
		error("Missing control: "..tostring(sid),2)
	end
	if ctrl then return ctrl:DynamicCast(ctrl:GetClassInfo():GetClassName()) end
end

tFuncs.InitTranslatableControls = function()
	for i,v in ipairs({"stb_hubname", "stb_hubtopic", "stb_hubdesc", "stb_hubaddress", "stb_ipv4addr", "stb_ipv6addr", "stb_tcp", "stb_udp", "stb_adminnick", "stb_hublistregs",
		-- 2. Advanced,
		"stb_hubstartup", "stb_hubcommands", "stt_cmdprefixes", "stb_scripting", "stb_kickmessages", "stb_statusmessages", "stb_pinger", "stb_welcome",
		-- 3. Rules,
		"stb_nicklimits", "stt_minnicklen", "stt_maxnicklen", "stb_nicklimitmsg", "stb_sharelimits", "stt_minshare", "stt_maxshare",
		"stb_sharelimitmsg", "stb_nicklimitredirect", "stb_sharelimitredirect",

		-- 4. DeFlood,
		"stb_defloodglobal", "stt_sec1", "stt_for", "stt_sec2", "stb_defloodmain", "stt_seconds1", "stt_seconds2", "stt_interval1",
		"stt_seconds3", "stb_defloodmainsame", "stt_seconds4", "stb_defloodmainsameml", "stt_with1", "stt_lines1", "stb_defloodctm",
		"stt_seconds5", "stt_seconds6", "stb_defloodrctm", "stt_seconds7", "stt_seconds8", "stb_defloodmainlimits", "stt_limit_length1",
		"stt_limit_lines1", "stb_defloodtempban", "stt_minutes1", "stb_defloodmaxuserlogins", "stt_per10sec", "stb_defloodctmlen",
		"stt_max1", "stb_defloodrctmlen", "stt_max2",
		-- 5. MOTD,
		"stb_motd",
		-- 6. Default bots,
		"stb_hubbot", "stb_hubbotnick", "stb_hubbotdesc", "stb_hubbotemail", "stb_opchat", "stb_opchatnick", "stb_opchatdesc",
		"stb_opchatemail",
		-- 7. More general,
		"stb_maxusers", "stb_language", "stb_defaulttempban", "stt_minutes2", "stb_textfiles", "stb_hubowneremail", "stb_mainrediraddr",
		"stb_regonlyhub", "stb_regonlymsg", "stb_regonlyrediraddr",
		-- 8. Ban handling,
		"stb_banmessage", "stb_banmsgaddmsg", "stb_tempbanrediraddr", "stb_permbanrediraddr",
		-- 9. MyINFO processing,
		"stb_myinfoprocessing", "stt_myinfosendminutes", "stb_desctag", "stb_userwotag", "stb_userwotagmsg", "stb_userwotagrediraddr", "stb_shortmyinfooptions", "stt_sendlongmyinfo",
		-- 10. Advanced security,
		"stb_experts", "stb_passwordprot", "stb_passwordbruteforce", "stt_passwordbftbt", "stt_passwordhours",
		-- 11. More rules,
		"stb_hubslimits", "stt_maxhubs", "stb_maxhubsmsg", "stb_slotslimits", "stt_minslots", "stt_maxslots", "stb_slotsmsg",
		"stb_hubslotslimits", "stt_hubslothubs", "stt_hubslotslots", "stb_hubslotsmsg", "stb_slotsredirect", "stb_hubslotsredirect", "stb_maxhubsredirect",
		-- 12. More deflood,
		"stb_defloodprivate", "stt_seconds9", "stt_seconds10", "stt_interval2", "stt_seconds11", "stb_defloodprivatesame",
		"stt_seconds12", "stb_deflood_privatesameml", "stt_with2", "stt_lines2", "stb_defloodprivperuser", "stt_defloodmaxmsgs",
		"stb_defloodreceiveddata", "stt_seconds13", "stt_seconds14", "stb_defloodwarns", "stt_after", "stt_warnings",
		"stb_defloodnewconnsameip", "stt_seconds15", "stb_defloodprivatelimits", "stt_limit_length2", "stt_limit_lines2",
		"stb_defloodmaxusersfromsameip", "stb_defloodreconntime", "stt_min", "stt_sec3",
		-- 13. More more deflood,
		"stb_defloodsearch", "stt_seconds16", "stt_seconds17", "stt_interval3", "stt_seconds18", "stb_defloodsearchsame",
		"stt_seconds19", "stb_searchreply", "stt_seconds20", "stt_seconds21", "stb_defloodmaxsr", "stb_defloodgetnicklist",
		"stt_minutes3", "stb_defloodmyinfo", "stt_seconds22", "stt_seconds23", "stb_defloodsearchlimits", "stt_minimum",
		"stt_max3", "stb_defloodsrlimit", "stt_max4", "stb_defloodmyinfolimit", "stt_max5",
		-- Registered users tab,
		"stb_regusers", "stb_profman", "stb_profperm"}) do tCtrls[v] = tFuncs.GetCtrl(v) end

	for _, v in ipairs({
		-- Settings tab
		"ACCEPT", "REFRESH", "IP2C_UPLOADV4", "IP2C_UPLOADV6", "IP2C_RELOAD",
		-- 1. General settings
		-- Scripts tab
		"LUA_REFRESH", "LUA_UP", "LUA_DOWN", "LUA_MEMORY", "LUA_RESTART", "LUA_LOAD", "LUA_SAVE", "LUA_NEW", "LUA_UPLOAD",
		-- Registered users tab
		"REG_RELOAD", "REG_ADD", "REG_MOD", "REG_DEL", "PROF_RELOAD", "PROF_ALL", "PROF_CLEAR", "PROF_UP", "PROF_DOWN", "PROF_ADD", "PROF_DEL",
		-- Bans tab
		"ADD_BAN", "REFRESH_BANS", "CLEAR_TB", "CLEAR_PB", "ADD_RANGEBAN", "REFRESH_RANGEBANS", "CLEAR_TRB", "CLEAR_PRB",
		-- Texts tab
		"TEXT_RELOADLIST", "TEXT_RELOAD", "TEXT_LOAD", "TEXT_SAVE", "TEXT_NEW", "TEXT_UPLOAD",
	}) do
		tCtrls[v] = tFuncs.GetCtrl("wxID_"..v)
	end
end

tFuncs.SetStatusText = function(text)
	tCtrls["statusbar"]:SetStatusText(text,1)
	tCtrls["txt_status"]:AppendText("\r\n"..os.date("[%H:%M:%S] ")..text)
	tCtrls["txt_status"]:ShowPosition(tCtrls["txt_status"]:GetLastPosition())
end

tFuncs.ChatStyle = function(style)
	tCtrls["ChatStyle"]:SetFont(tCtrls.ChatFonts[style])
	tCtrls["ChatStyle"]:SetTextColour(tCtrls.ChatColors[style])
end

tFuncs.ToChat = function(text,style)
	style = style or "Default"
	tFuncs.ChatStyle("Time")
	tCtrls["mainchat"]:AppendText("\r\n"..os.date("[%H:%M:%S]"))
	local nick, msg = text:match("^<([^ ]+)>%s(.+)$")
	if nick and msg then
		tFuncs.ChatStyle(style)
		tCtrls["mainchat"]:AppendText(" <")
		if nick == tData.CurrentHub.Nick then
			tFuncs.ChatStyle("MyNick")
		elseif tHubData.tOpList[nick] then
			tFuncs.ChatStyle("OpNick")
		else
			tFuncs.ChatStyle("Nick")
		end
		tCtrls["mainchat"]:AppendText(nick)
		tFuncs.ChatStyle(style)
		tCtrls["mainchat"]:AppendText("> "..msg)
	else
		tFuncs.ChatStyle(style)
		tCtrls["mainchat"]:AppendText(" "..text)	
	end
	tCtrls["mainchat"]:SetSelection(tCtrls["mainchat"]:GetLastPosition(),tCtrls["mainchat"]:GetLastPosition())
end


tFuncs.ConvertShare = function(iBytes)
	if not iBytes then return 0 end
	local i,tUnits = 1, {"B","Kb","Mb","Gb","Tb","Pb","Eb","Yb"}
	while iBytes > 1024 do iBytes = iBytes / 1024 i = i + 1 end
	return string.format("%.2f",iBytes).." "..(tUnits[i] or "??")
end

tFuncs.IsIP = function(str)
	return not not str:find("^[12]?[%d]?%d%.[12]?[%d]?%d%.[12]?[%d]?%d%.[12]?[%d]?%d$")
end

tFuncs.IP2DEC = function(sIP)
    local iDec,iNum = 0,0
	for num in sIP:gmatch("(%d+)") do
		iNum = iNum + 1
		if tonumber(num) < 0 or tonumber(num) > 255 then return -1 end
		iDec = iDec + num*256^(4-iNum)
	end
	if iNum ~= 4 then return -1 end
	return iDec
end

tFuncs.SortListItems = function(col,lst)
	-- This function is stripped and converted from bindings.wx.lua (c) John Labenski (5/7/2007)
	local sorted = false
	local tLst2Table = {["lst_bans"] = "tBans",["lst_rangebans"] = "tRangeBans",["lst_regs"] = "tRegs"}
	if tData.tSortedLists[lst] then
		sorted = true
	end
	local function SortListItems(item1,item2,col) -- The first two parameters automatically comes. Read the manual.
		local i1,i2 = "",""
		i1 = tHubData[tLst2Table[lst]][item1+1][col]:lower()
		i2 = tHubData[tLst2Table[lst]][item2+1][col]:lower()
		-- sort on the real numbers, but treat "" as lower
		if (i1 == "") and (i2 == "") then
			i1, i2 = 0, 0
		elseif (i1 == "") then
			i1, i2 = 0, 1
		elseif (i2 == "") then
			i1, i2 = 1, 0
		end
		if sorted then
			if i1 < i2 then return	1 end
			if i1 > i2 then return -1 end
		else
			if i1 < i2 then return -1 end
			if i1 > i2 then return	1 end
		end
		return 0
	end
	tCtrls[lst]:SortItems(SortListItems, col+1)
	if sorted then
		tData.tSortedLists[lst] = nil
	else
		tData.tSortedLists[lst] = 1
	end
end

tFuncs.CleanUp = function()
	wx.wxEndBusyCursor() -- Maybe some operations were in progress

	tFuncs.UDPDebugEnable(true)

	if tHubData.IP2C and tHubData.IP2C.File and io.type(tHubData.IP2C.File) == "file" then
		tHubData.IP2C.File:close()
	end
	
	tFuncs.InitHubData()

	tFuncs.GetCtrl("ID_STT_CORE"):SetLabel("")
	tFuncs.GetCtrl("ID_STT_CMDS"):SetLabel("")
	tFuncs.GetCtrl("ID_STT_CPU"):SetLabel("")

	tCtrls["lst_scripts"]:Clear()
	tCtrls["lst_bans"]:DeleteAllItems()
	tCtrls["lst_rangebans"]:DeleteAllItems()
	tCtrls["lst_regs"]:DeleteAllItems()
	tCtrls["lst_profiles"]:Clear()
	tFuncs.CleanUpSettings()
	tFuncs.CleanUpProfiles()
	if tData.TrayIcon then
		tCtrls["taskbar"]:SetIcon(tCtrls["icon_r"],_APPNAME.." ".._APPVER)
	end
	tCtrls["app"]:SetTitle(_APPNAME.." ".._APPVER)
	tCtrls["lst_texts"]:Clear()
	tFuncs.EnableControls(false)

	for index,thread in ipairs(tData.tDeadThreads) do
		ThreadDestroy(thread)
	end
end

tFuncs.CleanUpFinal = function()
	
	tCtrls["tab"]:SetSelection(0)

	tFuncs.GetCtrl("wxID_CMD_LOGIN"):SetLabel(tLang.Connection)
	tFuncs.GetCtrl("wxID_HUB"):Enable(true)
	tFuncs.GetCtrl("wxID_CMD_ADDHUB"):Enable(true)
	tFuncs.GetCtrl("wxID_CMD_MODHUB"):Enable(true)
	tFuncs.GetCtrl("wxID_CMD_DELHUB"):Enable(true)
	tFuncs.GetCtrl("ID_CMD_CLIPBOARD"):Enable(false)
	tFuncs.GetCtrl("ID_CMD_REFRESH"):Enable(false)

	if tData.Client then pcall(tData.Client.close,tData.Client) end

	tData.CurrentHub = nil
	tData.bReconnect = nil
	tData.bConnected = nil
	
	collectgarbage("collect")

	if tData.TCPThread then
		ThreadDestroy(tData.TCPThread)
	end
	tData.TCPThread = nil
	
	ThreadDestroyMutex(mutex)
	mutex = ThreadNewMutex()
end

tFuncs.CleanUpProfiles = function()
	for i=0,tData.iPermMax do
	    tCtrls["lst_permissions"]:Check(i,false)
	end
end

tFuncs.CleanUpSettings = function()
	for i=0,tData.iChkMax do
		if tCtrls["chk"]["chk_"..i] then
			tCtrls["chk"]["chk_"..i]:SetValue(false)
			tCtrls["chk"]["chk_"..i]:Enable(false)
		end
	end
	for i=0,tData.iNumMax do
		if tCtrls["num"]["num_"..i] then
			if tCtrls["num"]["num_"..i]:GetClassInfo():GetClassName() == "wxSpinCtrl" then
				tCtrls["num"]["num_"..i]:SetValue(0)
			else
				tCtrls["num"]["num_"..i]:SetSelection(0)
			end
			tCtrls["num"]["num_"..i]:Enable(false)
		end
	end
	for i=0,tData.iTxtMax do
		if tCtrls["txt"]["txt_"..i] then
			if tCtrls["txt"]["txt_"..i]:GetClassInfo():GetClassName() == "wxTextCtrl" then
				tCtrls["txt"]["txt_"..i]:SetValue("")
			else
				tCtrls["txt"]["txt_"..i]:SetSelection(0)
			end
			tCtrls["txt"]["txt_"..i]:Enable(false)
		end
	end
	tCtrls["txt"]["txt_motd"]:SetValue("")
	tCtrls["txt"]["txt_motd"]:Enable(false)
end

tFuncs.EnableControls = function(state,ctype)
	if not ctype or ctype == 1 then	-- 
		for _, v in ipairs({"stt_after", "stt_cmdprefixes", "stt_defloodmaxmsgs", "stt_for", "stt_hubslothubs", "stt_hubslotslots",
				"stt_interval1", "stt_interval2", "stt_interval3", "stt_limit_length1", "stt_limit_length2", "stt_limit_lines1",
				"stt_limit_lines2", "stt_lines1", "stt_lines2", "stt_max1", "stt_max2", "stt_max3", "stt_max4", "stt_max5",
				"stt_maxhubs", "stt_maxnicklen", "stt_maxshare", "stt_maxslots", "stt_min", "stt_minimum", "stt_minnicklen",
				"stt_minshare", "stt_minslots", "stt_minutes1", "stt_minutes2", "stt_minutes3", "stt_myinfosendminutes", 
				"stt_passwordbftbt", "stt_passwordhours", "stt_per10sec", "stt_sec1", "stt_sec2", "stt_sec3", "stt_seconds1",
				"stt_seconds10", "stt_seconds11", "stt_seconds12", "stt_seconds13", "stt_seconds14", "stt_seconds15", "stt_seconds16",
				"stt_seconds17", "stt_seconds18", "stt_seconds19", "stt_seconds2", "stt_seconds20", "stt_seconds21", "stt_seconds22",
				"stt_seconds23", "stt_seconds3", "stt_seconds4", "stt_seconds5", "stt_seconds6", "stt_seconds7", "stt_seconds8",
				"stt_seconds9", "stt_warnings", "stt_with1", "stt_with2"}) do
			tCtrls[v]:Enable(state)
		end
		tFuncs.GetCtrl("stt_kb1"):Enable(state)
		tFuncs.GetCtrl("stt_kb2"):Enable(state)
		for i = 1,23 do
			tFuncs.GetCtrl("wxID_STATIC"..i):Enable(state)
		end
		tCtrls["REFRESH"]:Enable(state)
		tCtrls["settings_tree"]:Enable(state)
		tCtrls["ACCEPT"]:Enable(state)
	end
	if not ctype or ctype == 2 then	-- 
		tCtrls["lst_scripts"]:Enable(state)
		for _, v in ipairs({"LUA_REFRESH", "LUA_UP", "LUA_DOWN", "LUA_MEMORY", "LUA_RESTART", "LUA_NEW", "LUA_UPLOAD"}) do
			tCtrls[v]:Enable(state)
		end
	end
	if not ctype or ctype == 3 then	-- 
		tCtrls["lst_regs"]:Enable(state)
		for _, v in ipairs({"REG_RELOAD", "REG_ADD", "REG_MOD", "REG_DEL"}) do
			tCtrls[v]:Enable(state)
		end
	end
	if not ctype or ctype == 4 then	-- 
		tCtrls["lst_profiles"]:Enable(state)
		tCtrls["lst_permissions"]:Enable(state)
		for _, v in ipairs({"PROF_RELOAD", "PROF_ALL", "PROF_CLEAR", "PROF_UP", "PROF_DOWN", "PROF_ADD", "PROF_DEL"}) do
			tCtrls[v]:Enable(state)
		end
	end
	if not ctype or ctype == 5 then	-- 
		tCtrls["lst_bans"]:Enable(state)
		for _, v in ipairs({"ADD_BAN", "REFRESH_BANS", "CLEAR_TB", "CLEAR_PB"}) do
			tCtrls[v]:Enable(state)
		end
	end
	if not ctype or ctype == 6 then	-- 
		tCtrls["lst_rangebans"]:Enable(state)
		for _, v in ipairs({"ADD_RANGEBAN", "REFRESH_RANGEBANS", "CLEAR_TRB", "CLEAR_PRB"}) do
			tCtrls[v]:Enable(state)
		end
	end
	if not ctype or ctype == 7 then	--  
		tCtrls["lst_texts"]:Enable(state)
		for _, v in ipairs({"TEXT_RELOADLIST", "TEXT_RELOAD", "TEXT_NEW", "TEXT_UPLOAD"}) do
			tCtrls[v]:Enable(state)
		end
	end
	if not ctype or ctype == 8 then	-- IP-To-Country
		for _, v in ipairs({"IP2C_UPLOADV4", "IP2C_UPLOADV6", "IP2C_RELOAD"}) do
			tCtrls[v]:Enable(state)
		end
	end
end

tFuncs.LoadPermissions = function(iProfileNumber)
	local sProf = tHubData.tProfiles[tonumber(iProfileNumber)][2]
	for i = 1,#sProf do
		tCtrls["lst_permissions"]:Check(i-1,sProf:sub(i,i) == "1")
	end
end

tFuncs.FileAction = function(sFile,iMode)
	while true do
		if tHubData.tFiles[sFile] == 1 then
			local evt = wx.wxCommandEvent(wx.wxEVT_NULL,tCtrls["wxID_EVENT_TEXTFILE"])
			evt:SetString(sFile)
			evt:SetInt(iMode)
			tCtrls["app"]:AddPendingEvent(evt)
			tHubData.tFiles[sFile] = nil
			break
		end
	end
end

tFuncs.DownloadFile = function(file)
	tFuncs.Send("$GET 8 "..file)
	tHubData.tFiles[file] = 0
end

tFuncs.UploadIP2CBegin = function(ftype)
	local fname = ftype == 1 and "IpToCountry.csv" or "IpToCountry.6R.csv"
	local filename = wx.wxFileSelector(tLang.SelectFile, tCfg.LastDirIP2C or wx.wxStandardPaths.Get():GetDocumentsDir(),fname,"","CSV Files|*.csv",wx.wxFD_OPEN+wx.wxFD_FILE_MUST_EXIST)
	if filename and filename ~= "" then
		tCfg.LastDirIP2C = filename:match("^(.+[/\\]).-$")
		wx.wxBeginBusyCursor()
		local size = lfs.attributes(filename, "size")
		tHubData.IP2C = {FileType = ftype, FileSize = size, File = io.open(filename, "rb")}
		if not size or not tHubData.IP2C.File then
			wx.wxMessageBox(tLang.UnableToOpenFile..filename,tLang.Error)
			tHubData.IP2C = nil
			wx.wxEndBusyCursor()
			return
		end

		tCtrls["IP2C_UPLOADV4"]:Enable(false)
		tCtrls["IP2C_UPLOADV6"]:Enable(false)
		tCtrls["IP2C_RELOAD"]:Enable(false)

		wx.wxBeginBusyCursor()
		tFuncs.UploadIP2CPart(1)
		wx.wxEndBusyCursor()
		wx.wxEndBusyCursor()
	end
end

tFuncs.UploadIP2CPart = function(part)
	local pos = (part-1)*tData.iIP2CFilePart
	if pos > tHubData.IP2C.FileSize then
		tHubData.IP2C.File:close()
		tFuncs.Send("$SET 9 2 "..tHubData.IP2C.FileSize.." "..tHubData.IP2C.FileType)
	else
		tHubData.IP2C.File:seek("set", pos)
		tFuncs.Send("$SET 9 1 "..part.." "..tHubData.IP2C.File:read(tData.iIP2CFilePart))
	end
end

tFuncs.ReloadScripts = function()
	tCtrls["tScripts"] = {}
	tCtrls["lst_scripts"]:Clear()
	tFuncs.Send("$GET 4")
end

tFuncs.ReloadRegs = function()
	tHubData.tRegs = {}
	tCtrls["lst_regs"]:DeleteAllItems()
	tFuncs.Send("$GET 6")
end

tFuncs.ReloadBans = function()
	tHubData.tBans = {}
	tCtrls["lst_bans"]:DeleteAllItems()
	tFuncs.Send("$GET 3 0")
end

tFuncs.ReloadRangeBans = function()
	tHubData.tRangeBans = {}
	tCtrls["lst_rangebans"]:DeleteAllItems()
	tFuncs.Send("$GET 3 1")
end

tFuncs.ReloadTexts = function()
	if tHubData.bEntered then
		tCtrls["tText"] = {}
		tCtrls["lst_texts"]:Clear()
		tFuncs.Send("$GET 7")
	end
end

tFuncs.ReIndex = function(lstView,iFrom)
	for j=0,tCtrls[lstView]:GetItemCount()-1 do
		local item = tCtrls[lstView]:GetItemData(j)
		if item >= iFrom then
			tCtrls[lstView]:SetItemData(j,item-1)
		end
	end
end

tFuncs.CreateBan = function(t)
	-- Sent as string, easier than tons of string.finds which might be wrong...
	local sTemp = "t = {"..tostring(t[1])..","..tostring(t[2])..","..tostring(t[3])..","..(t[1] and string.format("%q", t[4]) or '""')..","..
	(t[3] and string.format("%q", t[5]) or '""')..","..string.format("%q", t[6])..","..string.format("%q", t[7])..","..tostring(t[8])..",}"
	tFuncs.Send("$SET 3 6 "..sTemp)
end

tFuncs.CreateRangeBan = function(t)
	local sTemp = "t = {"..string.format("%q", t[1])..","..string.format("%q", t[2])..","..tostring(t[3])..","..string.format("%q", t[4])..","..string.format("%q", t[5])..","..t[6].."}"
	tFuncs.Send("$SET 3 7 "..sTemp)
end

tFuncs.Unban = function(item)
	local selitem = tCtrls["lst_bans"]:GetItemData(item)+1
	if tHubData.tBans[selitem][2] == "" then -- just IP ban
		tFuncs.Send("$SET 3 0 "..item.." "..tHubData.tBans[selitem][1])
	else -- nick [and maybe also an IP] ban
		tFuncs.Send("$SET 3 0 "..item.." "..(tHubData.tBans[selitem][1] == "" and
		tHubData.tBans[selitem][2] or tHubData.tBans[selitem][2].." "..tHubData.tBans[selitem][1]))
	end
end

tFuncs.ParseStat = function(stat)
	local uptime,ver = stat:match("Uptime: (.-)%s+Version: (.-) built")
	if ver then sHubversion = ver:match("PtokaX DC Hub (%S+)") end
	local sessionpeak,totalpeak,online = stat:match("Users.-: %d+ / (%d+) %((%d+)%) / (%d+)")
	local share = stat:match("Users shared size:.-/ (.-B)")
	local cmds,cpumem,nw = stat:match("(Chat.-)%-%-.-(CPU usage.-)%-%-.-(SendRests.+)")
	tFuncs.GetCtrl("ID_STT_CORE"):SetLabel(uptime and share and sessionpeak and tLang.UpTime..": "..(uptime or "?").."\n"..tLang.Ver..": "..(ver or "?")..
		"\n\n"..tLang.UsersOnline..": "..(online or "?").."\n"..tLang.MaxUsersSession..": "..(sessionpeak or "?")..
		"\n"..tLang.MaxUsersAllTime..": "..(totalpeak or "?").."\n\n"..tLang.TotalShare..": "..(share or "?") or tLang.DataParsingError)
	tFuncs.GetCtrl("ID_STT_CMDS"):SetLabel(cmds or tLang.DataParsingError)
	tFuncs.GetCtrl("ID_STT_CPU"):SetLabel(cpumem and cpumem.."-------------------------\n"..nw or tLang.DataParsingError)
end

tFuncs.GetSelection = function(ListCtrl)
	local selitem = 0
	for i=0,ListCtrl:GetItemCount()-1 do
		if ListCtrl:GetItemState(i,wx.wxLIST_STATE_SELECTED) == wx.wxLIST_STATE_SELECTED then
			selitem = i
			break
		end
	end
	return selitem
end

tFuncs.Lock2Key = function(lock)
	local aKey = {}
	table.insert(aKey,bit.bxor(bit.bxor(bit.bxor(lock:byte(1),lock:byte(-1),lock:byte(-2),5))))
	for i=2,#lock do
		table.insert(aKey,bit.bxor(lock:byte(i),lock:byte(i-1)))
	end
	local t = {["0"]=1,["5"]=1,["36"]=1,["96"]=1,["124"]=1,["126"]=1}
	for i=1,#aKey do
		local b = bit.bor(bit.band(aKey[i]*(2^4),240),bit.band(math.floor(aKey[i]/(2^4)),15))
		aKey[i] = (t[tostring(b)] and string.format("/%%DCN%03d%%/",b) or string.char(b))
	end
	return table.concat(aKey)
end

tFuncs.Exit = function(event)
	tCfg.HubNumber = tCtrls["hub_select"]:GetSelection()+1
	if tData.bConnected then
		if tCfg.LastState then
			tCfg.Connect = true
		end
		tFuncs.CleanUp()
		tFuncs.CleanUpFinal()
	end
	for _,v in ipairs({{"lst_regs","RegCol_",3},{"lst_bans","BanCol_",5},{"lst_rangebans","RangeBanCol_",4}}) do
		for i=1,v[3] do
			tCfg[v[2]..i] = tCtrls[v[1]]:GetColumnWidth(i-1)
		end
	end
	if tCtrls["app"]:IsMaximized() then
		tCfg.Maximized = true
	else
		tCfg.Maximized = false
		tCfg.Width,tCfg.Height = tCtrls["app"]:GetSizeWH()
	end
	tCfg.EditorSplit = tFuncs.GetCtrl("ID_SPLITTERWINDOW2"):GetSashPosition()
	SaveCfg()
	if tData.TrayIcon then
		tCtrls["taskbar"]:RemoveIcon()
	end
	--event:Skip()
	if not wx.__WXMSW__ then
		tCtrls["app"]:Close() -- Unix needs it, on win it cause a stack overflow 8-|
	end
	wx.wxExit(0)
end
