--[[##################################################################################

	PXControl by alex82
	Based on Ptokax Remote Administration by Hungarista

####################################################################################

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

###################################################################################]]

tCtrls["app"]:Connect(tCtrls["wxID_EVENT_TEXTFILE"],wx.wxEVT_NULL,
function(event)
	if event:GetInt() == 0 then
		editor:LoadFile(_save_path.."scripts/"..event:GetString())
	elseif event:GetInt() == 1 then
		tFuncs.GetCtrl("txt_texteditor"):LoadFile(_save_path.."texts/"..event:GetString())
	elseif event:GetInt() == 2 then
		local script = event:GetString()
		local res,err = loadfile(_save_path.."scripts/"..script)
		if res then
			tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..tLang.NoSyntaxErrorsInScript.." "..script.."\n")
		else
			tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..tLang.Syntax.." "..tostring(err):sub(9).."\n")
		end
	else
		if wx.__WXMSW__ then
			process.exec(_save_path.."scripts/"..event:GetString(),"",1)
		else
			os.execute(_save_path.."scripts/"..event:GetString())
		end
	end
end)

-- Real event handlers
tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_BUTTON_CLICKED,
function(event)
	local tButtonEvtIds = {
	[tCtrls["wxID_CMD_LOGIN"]] = function()
		if tFuncs.GetCtrl("wxID_CMD_LOGIN"):GetLabel() == (tLang.Disconnect) then
			tFuncs.SetStatusText(tLang.Disconnected)
			tFuncs.CleanUp()
			tFuncs.CleanUpFinal()
		else
			tFuncs.Connect()
		end
	end,
	[wx.wxID_ABOUT] = function()
		tDialogs.About()
	end,
	[tCtrls["wxID_CMD_ADDHUB"]] = function()
		tDialogs.HubSettings()
	end,
	[tCtrls["wxID_CMD_MODHUB"]] = function()
		local hubnumber = tCtrls["hub_select"]:GetSelection()+1
		if tHubs[hubnumber] then
			tDialogs.HubSettings(hubnumber)
		end
	end,
	[tCtrls["wxID_CMD_DELHUB"]] = function()
		local hubnumber = tCtrls["hub_select"]:GetSelection()+1
		if tHubs[hubnumber] then
			if wx.wxMessageBox(tLang.DoYouReallyWantToDeleteHub,tLang.Attention,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
				table.remove(tHubs,hubnumber)
				SaveHubs()
				tCtrls["hub_select"]:Delete(hubnumber-1)
				if #tHubs > 0 then tCtrls["hub_select"]:SetSelection(0) end
			end
		end
	end,
	[tCtrls["ID_CMD_CLIPBOARD"]] = function()
		if wx.wxClipboard.Get():Open() then
			-- Not the same as Px sent...
			local stats = tFuncs.GetCtrl("ID_STT_CORE"):GetLabel().."\r\n"..tFuncs.GetCtrl("ID_STT_CMDS"
			):GetLabel().."\r\n"..tFuncs.GetCtrl("ID_STT_CPU"):GetLabel()
			wx.wxClipboard.Get():SetData(wx.wxTextDataObject(stats))
			wx.wxClipboard.Get():Close()
		end
	end,
	[tCtrls["ID_CMD_REFRESH"]] = function()
		tFuncs.GetStats()
	end,
	[tCtrls["wxID_CMD_PWGEN"]] = function()
		tDialogs.GeneratePassword()
	end,
	[tCtrls["wxID_REFRESH"]] = function()
		if tHubData.bEntered then
			tFuncs.CleanUpSettings()
			tFuncs.EnableControls(false, 1)
			tHubData.tSettings = {
				["chk"] = {},
				["txt"] = {},
				["num"] = {},
			}
			
			tFuncs.Send("$GET 0")
			tFuncs.Send("$GET 1")
			tFuncs.Send("$GET 2")
		end
	end,
	[tCtrls["wxID_ACCEPT"]] = function()
		if tHubData.bEntered then
		    wx.wxBeginBusyCursor()
			local tSet, iSetNum = {}, 0
			for i=0,tHubData.tMax.chk do
			    if tCtrls["chk"]["chk_"..i] and (tCtrls["chk"]["chk_"..i]:GetValue() and "1" or "0") ~= tHubData.tSettings["chk"][i] then
					iSetNum = iSetNum+1
					table.insert(tSet,i.."$"..(tCtrls["chk"]["chk_"..i]:GetValue() and "1" or "0"))
					tHubData.tSettings["chk"][i] = (tCtrls["chk"]["chk_"..i]:GetValue() and "1" or "0") -- update
				end
			end
			if next(tSet) then -- Did we modify something?
				tFuncs.Send("$SET 0 "..table.concat(tSet,"$$").."$$")
			end
			tSet = {}
			for i=0,tHubData.tMax.num do
				if tCtrls["num"]["num_"..i] then
					if tCtrls["num"]["num_"..i]:GetClassInfo():GetClassName() == "wxSpinCtrl" then
					    if tostring(tCtrls["num"]["num_"..i]:GetValue()) ~= tHubData.tSettings["num"][i] then
							iSetNum = iSetNum+1
							table.insert(tSet,i.."$"..tostring(tCtrls["num"]["num_"..i]:GetValue()))
							tHubData.tSettings["num"][i] = tostring(tCtrls["num"]["num_"..i]:GetValue())
						end
					else
					    if tostring(tCtrls["num"]["num_"..i]:GetSelection()) ~= tHubData.tSettings["num"][i] then
							iSetNum = iSetNum+1
							table.insert(tSet,i.."$"..tostring(tCtrls["num"]["num_"..i]:GetSelection()))
							tHubData.tSettings["num"][i] = tostring(tCtrls["num"]["num_"..i]:GetSelection())
						end
					end
				end
			end
			if next(tSet) then
				tFuncs.Send("$SET 1 "..table.concat(tSet,"$$").."$$")
			end
			local motd = tCtrls["txt"]["txt_motd"]:GetValue():gsub("\n","\r\n")
			if motd ~= tHubData.tSettings["txt"]["motd"] then
				iSetNum = iSetNum+1
				tFuncs.Send("$SET 2 motd "..motd)
				tHubData.tSettings["txt"]["motd"] = motd
			end
			tSet = {}
			for i=0,tHubData.tMax.txt do
				if tCtrls["txt"]["txt_"..i] then
				    if i == 34 then
						local val = tCtrls["txt"]["txt_34"]:GetStringSelection()
						if val == "Default English" then val = "" end
				        if val ~= tHubData.tSettings["txt"][34] then
							iSetNum = iSetNum+1
					 		table.insert(tSet,i.."$"..(tCtrls["txt"]["txt_"..i]:GetStringSelection() == "Default English" and "" or tCtrls["txt"]["txt_"..i]:GetStringSelection()))
					 		tHubData.tSettings["txt"][i] = val
						end
					else
					    if tCtrls["txt"]["txt_"..i]:GetValue() ~= tHubData.tSettings["txt"][i] then
							iSetNum = iSetNum+1
					 		table.insert(tSet,i.."$"..(tCtrls["txt"]["txt_"..i]:GetValue():gsub("%$|","")))
					 		tHubData.tSettings["txt"][i] = tCtrls["txt"]["txt_"..i]:GetValue()
						end
					end
				end
			end
			if next(tSet) then
				tFuncs.Send("$SET 2 "..table.concat(tSet,"$$").."$$")
			end
			if iSetNum == 0 then
				tFuncs.SetStatusText(tLang.SettingsNotChanged)
			else
				tFuncs.SetStatusText(tLang.SavedFormatParameters:format(iSetNum))
			end
			wx.wxEndBusyCursor()
		end
	end,
	[tCtrls["wxID_IP2C_UPLOADV4"]] = function()
		if tHubData.bEntered then
			tFuncs.UploadIP2CBegin(1)
		end
	end,
	[tCtrls["wxID_IP2C_UPLOADV6"]] = function()
		if tHubData.bEntered then
			tFuncs.UploadIP2CBegin(2)
		end
	end,
	[tCtrls["wxID_IP2C_RELOAD"]] = function()
		if tHubData.bEntered then
			tFuncs.Send("$SET 8")
		end
	end,
	[tCtrls["wxID_LUA_LOAD"]] = function()
		local filename = wx.wxFileSelector(tLang.LoadScript, tCfg.LastDirLua or wx.wxStandardPaths.Get():GetDocumentsDir(),"","","*.lua",wx.wxFD_OPEN + wx.wxFD_FILE_MUST_EXIST)
		if filename ~= "" then
			tCfg.LastDirLua = filename:match("^(.+[/\\]).-$")
			local f = io.open(filename,"rb")
			if f then
				if tEditor then
					editor:SetText(f:read("*a"))
				else
					editor:SetValue(f:read("*a"))
				end
				f:close()
			else
				wx.wxMessageBox(tLang.UnableToOpenFile..filename,tLang.Error)
			end
		end
	end,
	[tCtrls["wxID_LUA_SAVE"]] = function()
		local filename = wx.wxFileSelector(tLang.SaveScript, tCfg.LastDirLua or wx.wxStandardPaths.Get():GetDocumentsDir(),"","","*.lua",wx.wxFD_SAVE+wx.wxFD_OVERWRITE_PROMPT)
		if filename ~= "" then
			tCfg.LastDirLua = filename:match("^(.+[/\\]).-$")
			if filename:sub(-4):lower() ~= ".lua" then filename = filename..".lua" end
			local f = io.open(filename,"wb")
			if f then
				if tEditor then
					f:write(editor:GetText())
				else
					f:write(editor:GetValue())
				end
				f:close()
			else
				wx.wxMessageBox(tLang.UnableToOpenFile..filename,tLang.Error)
			end
		end
	end,
	[tCtrls["wxID_LUA_REFRESH"]] = function()
		if tHubData.bEntered then
			tFuncs.EnableControls(false, 2)
			tFuncs.ReloadScripts()
		end
	end,
	[tCtrls["wxID_LUA_NEW"]] = function()
		if tHubData.bEntered then
			local name = wx.wxGetTextFromUser(tLang.SpecifyFileNameNoExt,tLang.New)
			if name and name ~= "" then
				if tCtrls["tScripts"][name..".lua"] then
					tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..tLang.FileAlreadyExist.."\n")
				else
					tFuncs.Send("$SET 7 "..name..".lua:")
					tFuncs.ReloadScripts()
				end
			end
		end
	end,
	[tCtrls["wxID_LUA_UPLOAD"]] = function()
		if tHubData.bEntered then
			local filename = wx.wxFileSelector(tLang.SelectFile, tCfg.LastDirLua or wx.wxStandardPaths.Get():GetDocumentsDir(),"","","*.lua",wx.wxFD_OPEN)
			if filename and filename ~= "" then
				tCfg.LastDirLua = filename:match("^(.+[/\\]).-$")
				local name = filename:match("^.+[/\\](.-).lua$")
				if name and name ~= "" then
					if not tCtrls["tScripts"][name..".lua"] or wx.wxMessageBox(tLang.FileAlreadyExistOverwrite,_APPNAME,wx.wxICON_EXCLAMATION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
						local f = io.open(filename,"rb")
						if f then
							tFuncs.Send("$SET 7 "..name..".lua:"..f:read("*a"))
							f:close()
							tFuncs.ReloadScripts()
						else
							tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..tLang.UnableToOpenFile.."\n")
						end
					end
				end
			end
		end
	end,
	[tCtrls["wxID_LUA_DOWN"]] = function()
		if tHubData.bEntered then
			if tCtrls["lst_scripts"]:GetSelections() > 0 then
			    wx.wxBeginBusyCursor()
				tFuncs.Send("$SET 4 "..tCtrls["lst_scripts"]:GetStringSelection().." 0")
			end
		end
	end,
	[tCtrls["wxID_LUA_UP"]] = function()
		if tHubData.bEntered then
			if tCtrls["lst_scripts"]:GetSelections() > 0 then
			    wx.wxBeginBusyCursor()
				tFuncs.Send("$SET 4 "..tCtrls["lst_scripts"]:GetStringSelection().." 1")
			end
		end
	end,
	[tCtrls["wxID_LUA_MEMORY"]] = function()
		if tHubData.bEntered then
			tDialogs.Memory()
		end
	end,
	[tCtrls["wxID_LUA_RESTART"]] = function()
		if tHubData.bEntered then
			tFuncs.Send("$RSS")
			tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..tLang.RestartingScripts.."\n")
		end
	end,
	[tCtrls["wxID_CLEAR_EDITOR"]] = function()
		if tEditor then
			editor:ClearAll()
		else
			editor:Clear()
		end
	end,
	[tCtrls["wxID_CLEAR_ERROR"]] = function()
	    tCtrls["txt_scripterror"]:Clear()
	end,
	[tCtrls["wxID_REG_RELOAD"]] = function()
	    if tHubData.bEntered then
			tFuncs.EnableControls(false, 3)
			tFuncs.ReloadRegs()
		end
	end,
	[tCtrls["wxID_REG_ADD"]] = function()
	    if tHubData.bEntered then
	    	local nick,pass,profile = tDialogs.RegUser()
	    	if nick and pass and #pass > 0 then -- Maybe cancelled, check it
	    		tFuncs.Send("$SET 6 1 "..nick.." "..pass.." "..profile)
			end
		end
	end,
	[tCtrls["wxID_REG_MOD"]] = function()
	    if tHubData.bEntered then
	        if tCtrls["lst_regs"]:GetSelectedItemCount() ~= 0 then
				local item = tFuncs.GetSelection(tCtrls["lst_regs"])
				local iPos = tCtrls["lst_regs"]:GetItemData(item)+1
				local onick = tCtrls["lst_regs"]:GetItemText(item)
				local nick,pass,profile = tDialogs.RegUser(tHubData.tRegs[iPos][1],tHubData.tRegs[iPos][2],tHubData.tRegs[iPos][3])
				if nick then -- if not cancelled
					if nick == onick then
						tFuncs.Send("$SET 6 2 "..nick.." "..pass.." "..profile)
					else
						tCtrls["lst_regs"]:DeleteItem(item)
					    tFuncs.Send("$SET 6 1 "..nick.." "..pass.." "..profile)
					end
				end
			end
		end
	end,
	[tCtrls["wxID_REG_DEL"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
	        if tCtrls["lst_regs"]:GetSelectedItemCount() ~= 0 then
				local item = tFuncs.GetSelection(tCtrls["lst_regs"])
				local nick = tCtrls["lst_regs"]:GetItemText(item)
				if nick ~= tData.CurrentHub.Nick or wx.wxMessageBox(tLang.DelSelfAccountMsg,tLang.Attention,wx.wxICON_EXCLAMATION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
					tFuncs.Send("$SET 6 0 "..nick)
				end
			end
	    end
	end,
	[tCtrls["wxID_PROF_RELOAD"]] = function()
		if tHubData.bEntered then
			tFuncs.EnableControls(false, 4)
			tHubData.tProfiles = {}
			tCtrls["lst_profiles"]:Clear()
			for i=0,tData.iPermMax do
			    tCtrls["lst_permissions"]:Check(i,false)
			end
			tFuncs.Send("$GET 5")
		end
	end,
	[tCtrls["wxID_PROF_ALL"]] = function()
		if tHubData.bEntered then
			tFuncs.Send("$SET 5 "..tCtrls["lst_profiles"]:GetSelection().." p 99 1")
		end
	end,
	[tCtrls["wxID_PROF_CLEAR"]] = function()
		if tHubData.bEntered then
			tFuncs.Send("$SET 5 "..tCtrls["lst_profiles"]:GetSelection().." p 99 0")
		end
	end,
	[tCtrls["wxID_PROF_DOWN"]] = function()
		if tHubData.bEntered then
			if tCtrls["lst_profiles"]:GetSelection() >= 0 then
			    wx.wxBeginBusyCursor()
				tFuncs.Send("$SET 5 "..tCtrls["lst_profiles"]:GetSelection().." 0")
				tFuncs.GetCtrl("wxID_PROF_UP"):Enable(false)
				tFuncs.GetCtrl("wxID_PROF_DOWN"):Enable(false)
			end
		end
	end,
	[tCtrls["wxID_PROF_UP"]] = function()
		if tHubData.bEntered then
			if tCtrls["lst_profiles"]:GetSelection() >= 0 then
			    wx.wxBeginBusyCursor()
				tFuncs.Send("$SET 5 "..tCtrls["lst_profiles"]:GetSelection().." 1")
				tFuncs.GetCtrl("wxID_PROF_UP"):Enable(false)
				tFuncs.GetCtrl("wxID_PROF_DOWN"):Enable(false)
			end
		end
	end,
	[tCtrls["wxID_PROF_ADD"]] = function()
		if tHubData.bEntered then
	    	local newprofile = wx.wxGetTextFromUser(tLang.NewProfile,tLang.Name)
			-- GetTextFromUser hasn't got validator :-/
			newprofile = newprofile:gsub("[%$|%s]","") -- Remove dollars, endpipes and white chars
			if newprofile == "" then return end
            wx.wxBeginBusyCursor()
			for i=0,tCtrls["lst_profiles"]:GetCount() do
			    if tCtrls["lst_profiles"]:GetString(i):lower() == newprofile:lower() then
                    wx.wxEndBusyCursor()
					wx.wxMessageBox(tLang.ProfileNameExist)
					return
				end
			end
			tFuncs.Send("$SET 5 "..newprofile.." true")
		end
	end,
	[tCtrls["wxID_PROF_DEL"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
			if tCtrls["lst_profiles"]:GetSelections() > 0 then
			    wx.wxBeginBusyCursor()
				local bCanDelete = true
				for index,reguser in ipairs(tHubData.tRegs) do
					if reguser[3] == tCtrls["lst_profiles"]:GetStringSelection() then
						bCanDelete = nil
						break
					end
				end
				if bCanDelete then
					tFuncs.Send("$SET 5 "..tCtrls["lst_profiles"]:GetStringSelection().." false")
				else
					wx.wxMessageBox(tLang.ProfileDelFailed)
				end
			end
		end
	end,
	[tCtrls["wxID_ADD_BAN"]] = function()
		if not tHubData.bEntered then return end
		local tBan = tDialogs.Ban()
		if not tBan then return end
		tFuncs.CreateBan(tBan[2])
	end,
	[tCtrls["wxID_REFRESH_BANS"]] = function()
		if tHubData.bEntered then
		    tHubData.tBans = {}
		    tCtrls["lst_bans"]:DeleteAllItems()
			tFuncs.EnableControls(false, 5)
		    tFuncs.Send("$GET 3 0")
		end
	end,
	[tCtrls["wxID_CLEAR_TB"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
	    	wx.wxBeginBusyCursor()
	    	tFuncs.Send("$SET 3 1")
			tFuncs.ReloadBans()
		end
	end,
	[tCtrls["wxID_CLEAR_PB"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
        	wx.wxBeginBusyCursor()
	    	tFuncs.Send("$SET 3 2")
			tFuncs.ReloadBans()
		end
	end,
	[tCtrls["wxID_ADD_RANGEBAN"]] = function()
		if not tHubData.bEntered then return end
		local tBan = tDialogs.RangeBan()
		if not tBan then return end
		tFuncs.CreateRangeBan(tBan[2])
	end,
	[tCtrls["wxID_REFRESH_RANGEBANS"]] = function()
		if tHubData.bEntered then
		    tHubData.tRangeBans = {}
	   		tCtrls["lst_rangebans"]:DeleteAllItems()
			tFuncs.EnableControls(false, 6)
	    	tFuncs.Send("$GET 3 1")
	    end
	end,
	[tCtrls["wxID_CLEAR_TRB"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
        	wx.wxBeginBusyCursor()
	    	tFuncs.Send("$SET 3 4")
			tFuncs.ReloadRangeBans()
		end
	end,
	[tCtrls["wxID_CLEAR_PRB"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
        	wx.wxBeginBusyCursor()
	    	tFuncs.Send("$SET 3 5")
			tFuncs.ReloadRangeBans()
		end
	end,
	[tCtrls["wxID_TEXT_RELOADLIST"]] = function()
		tFuncs.EnableControls(false, 7)
		tFuncs.ReloadTexts()
	end,
	[tCtrls["wxID_TEXT_RELOAD"]] = function()
		-- No LUA support for it...
		if tHubData.bEntered then
			tFuncs.Send("<"..tData.CurrentHub.Nick.."> "..(tHubData.tSettings["txt"][29] and tHubData.tSettings["txt"][29]:sub(1,1) or "!").."reloadtxt")
		end
	end,
	[tCtrls["wxID_TEXT_LOAD"]] = function()
		local filename = wx.wxFileSelector(tLang.LoadFile, tCfg.LastDirText or wx.wxStandardPaths.Get():GetDocumentsDir(),"","","*.txt",wx.wxFD_OPEN+wx.wxFD_FILE_MUST_EXIST)
		if filename ~= "" then
			tCfg.LastDirText = filename:match("^(.+[/\\]).-$")
			local f = io.open(filename,"rb")
			if f then
				tFuncs.GetCtrl("txt_texteditor"):SetValue(f:read("*a"))
				f:close()
			else
				wx.wxMessageBox(tLang.UnableToOpenFile..filename,tLang.Error)
			end
		end
	end,
	[tCtrls["wxID_TEXT_SAVE"]] = function()
		local filename = wx.wxFileSelector(tLang.SaveFile, tCfg.LastDirText or wx.wxStandardPaths.Get():GetDocumentsDir(),"","","*.txt",wx.wxFD_SAVE+wx.wxFD_OVERWRITE_PROMPT)
		if filename ~= "" then
			tCfg.LastDirText = filename:match("^(.+[/\\]).-$")
			if filename:sub(-4) ~= ".txt" then filename = filename..".txt" end
			local f = io.open(filename,"wb")
			if f then
				f:write(tFuncs.GetCtrl("txt_texteditor"):GetValue())
				f:close()
			else
				wx.wxMessageBox(tLang.UnableToOpenFile..filename,tLang.Error)
			end
		end
	end,
	[tCtrls["wxID_TEXT_NEW"]] = function()
		if tHubData.bEntered then
			local name = wx.wxGetTextFromUser(tLang.SpecifyFileNameNoExt,tLang.Upload)
			if name and name ~= "" then
				if tHubData.tTexts[name] then
					wx.wxMessageBox(tLang.FileAlreadyExist,tLang.Error)
				else
					tFuncs.Send("$SET 7 "..name..".txt:")
					tFuncs.ReloadTexts()
				end
			end
		end
	end,
	[tCtrls["wxID_TEXT_UPLOAD"]] = function()
		if tHubData.bEntered then
			local filename = wx.wxFileSelector(tLang.SelectFile, tCfg.LastDirText or wx.wxStandardPaths.Get():GetDocumentsDir(),"","","*.txt",wx.wxFD_OPEN)
			if filename and filename ~= "" then
				tCfg.LastDirText = filename:match("^(.+[/\\]).-$")
				local name = filename:match("^.+[/\\](.-).txt$")
				if name and name ~= "" then
					if not tHubData.tTexts[name] or wx.wxMessageBox(tLang.FileAlreadyExistOverwrite,_APPNAME,wx.wxICON_EXCLAMATION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
						local f = io.open(filename,"rb")
						if f then
							tFuncs.Send("$SET 7 "..name..".txt:"..f:read("*a"))
							f:close()
							tFuncs.ReloadTexts()
						else
							wx.wxMessageBox(tLang.UnableToOpenFile..filename,tLang.Error)
						end
					end
				end
			end
		end
	end,
	[tCtrls["wxID_CMD_UDPSYS"]] = function()
		tFuncs.UDPEnableHideCtrls("SYS")
	end,
	[tCtrls["wxID_CMD_UDPERR"]] = function()
		tFuncs.UDPEnableHideCtrls("ERR")
	end,
	[tCtrls["wxID_CMD_UDPLUA"]] = function()
		tFuncs.UDPEnableHideCtrls("LUA")
	end,
	[tCtrls["wxID_CMD_UDPREG"]] = function()
		tFuncs.UDPEnableHideCtrls("REG")
	end,
	[tCtrls["wxID_CMD_UDPLOG"]] = function()
		tFuncs.UDPEnableHideCtrls("LOG")
	end,
	[tCtrls["wxID_CMD_UDPCLEAR"]] = function()
		local font = tCtrls["app"]:GetFont()
		for i,v in ipairs({"SYS","ERR","LUA","REG","LOG"}) do
			tFuncs.GetCtrl("wxID_TXT_UDP"..v):Clear()
			tFuncs.GetCtrl("wxID_CMD_UDP"..v):SetFont(font)
		end
	end,
	}
	if tButtonEvtIds[event:GetId()] then
		tButtonEvtIds[event:GetId()]()
	end
end)

tSpinCtrlEvtIds = {
	[tCtrls["xmlResource"].GetXRCID("num_60")] = function()
		if tCtrls["num"]["num_60"]:GetValue() == 0 and tCtrls["num"]["num_61"]:GetValue() == 0 then
			tCtrls["txt"]["txt_31"]:Enable(false)
			tCtrls["txt"]["txt_32"]:Enable(false)
			tCtrls["chk"]["chk_44"]:Enable(false)
		else
			tCtrls["txt"]["txt_31"]:Enable(true)
			if tCtrls["chk"]["chk_44"]:IsChecked() then
				tCtrls["txt"]["txt_32"]:Enable(true)
			end
			tCtrls["chk"]["chk_44"]:Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_61")] = function()
		if tCtrls["num"]["num_60"]:GetValue() == 0 and tCtrls["num"]["num_61"]:GetValue() == 0 then
			tCtrls["txt"]["txt_31"]:Enable(false)
			tCtrls["txt"]["txt_32"]:Enable(false)
			tCtrls["chk"]["chk_44"]:Enable(false)
		else
			tCtrls["txt"]["txt_31"]:Enable(true)
			if tCtrls["chk"]["chk_44"]:IsChecked() then
				tCtrls["txt"]["txt_32"]:Enable(true)
			end
			tCtrls["chk"]["chk_44"]:Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_1")] = function()
		if tCtrls["num"]["num_1"]:GetValue() == 0 and tCtrls["num"]["num_3"]:GetValue() == 0 then
			tCtrls["chk"]["chk_7"]:Enable(false)
			tCtrls["txt"]["txt_11"]:Enable(false)
			tCtrls["txt"]["txt_12"]:Enable(false)
		else
			tCtrls["chk"]["chk_7"]:Enable(true)
			tCtrls["txt"]["txt_11"]:Enable(true)
			if tCtrls["chk"]["chk_7"]:IsChecked() then
				tCtrls["txt"]["txt_12"]:Enable(true)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_3")] = function()
		if tCtrls["num"]["num_1"]:GetValue() == 0 and tCtrls["num"]["num_3"]:GetValue() == 0 then
			tCtrls["chk"]["chk_7"]:Enable(false)
			tCtrls["txt"]["txt_11"]:Enable(false)
			tCtrls["txt"]["txt_12"]:Enable(false)
		else
			tCtrls["chk"]["chk_7"]:Enable(true)
			tCtrls["txt"]["txt_11"]:Enable(true)
			if tCtrls["chk"]["chk_7"]:IsChecked() then
				tCtrls["txt"]["txt_12"]:Enable(true)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_9")] = function()
		if tCtrls["num"]["num_9"]:GetValue() == 0 then
			tCtrls["chk"]["chk_10"]:Enable(false)
			tCtrls["txt"]["txt_17"]:Enable(false)
			tCtrls["txt"]["txt_18"]:Enable(false)
		else
			tCtrls["chk"]["chk_10"]:Enable(true)
			tCtrls["txt"]["txt_17"]:Enable(true)
			if tCtrls["chk"]["chk_10"]:IsChecked() then
				tCtrls["txt"]["txt_18"]:Enable(true)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_7")] = function()
		if tCtrls["num"]["num_7"]:GetValue() == 0 and tCtrls["num"]["num_8"]:GetValue() == 0 then
			tCtrls["chk"]["chk_9"]:Enable(false)
			tCtrls["txt"]["txt_15"]:Enable(false)
			tCtrls["txt"]["txt_16"]:Enable(false)
		else
			tCtrls["chk"]["chk_9"]:Enable(true)
			tCtrls["txt"]["txt_15"]:Enable(true)
			if tCtrls["chk"]["chk_9"]:IsChecked() then
				tCtrls["txt"]["txt_16"]:Enable(true)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_8")] = function()
		if tCtrls["num"]["num_7"]:GetValue() == 0 and tCtrls["num"]["num_8"]:GetValue() == 0 then
			tCtrls["chk"]["chk_9"]:Enable(false)
			tCtrls["txt"]["txt_15"]:Enable(false)
			tCtrls["txt"]["txt_16"]:Enable(false)
		else
			tCtrls["chk"]["chk_9"]:Enable(true)
			tCtrls["txt"]["txt_15"]:Enable(true)
			if tCtrls["chk"]["chk_9"]:IsChecked() then
				tCtrls["txt"]["txt_16"]:Enable(true)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_5")] = function()
		if tCtrls["num"]["num_5"]:GetValue() == 0 and tCtrls["num"]["num_6"]:GetValue() == 0 then
			tCtrls["chk"]["chk_8"]:Enable(false)
			tCtrls["txt"]["txt_13"]:Enable(false)
			tCtrls["txt"]["txt_14"]:Enable(false)
		else
			tCtrls["chk"]["chk_8"]:Enable(true)
			tCtrls["txt"]["txt_13"]:Enable(true)
			if tCtrls["chk"]["chk_8"]:IsChecked() then
				tCtrls["txt"]["txt_14"]:Enable(true)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_6")] = function()
		if tCtrls["num"]["num_5"]:GetValue() == 0 and tCtrls["num"]["num_6"]:GetValue() == 0 then
			tCtrls["chk"]["chk_8"]:Enable(false)
			tCtrls["txt"]["txt_13"]:Enable(false)
			tCtrls["txt"]["txt_14"]:Enable(false)
		else
			tCtrls["chk"]["chk_8"]:Enable(true)
			tCtrls["txt"]["txt_13"]:Enable(true)
			if tCtrls["chk"]["chk_8"]:IsChecked() then
				tCtrls["txt"]["txt_14"]:Enable(true)
			end
		end
	end,
}
tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_TEXT_UPDATED,
function(event)
	if tSpinCtrlEvtIds[event:GetId()] then
	    tSpinCtrlEvtIds[event:GetId()]()
	end
end)

tCheckBoxEvtIds = {
	[tCtrls["xmlResource"].GetXRCID("chk_44")] = function()
		if tCtrls["chk"]["chk_44"]:GetValue() then
			tCtrls["txt"]["txt_32"]:Enable(true)
		else
			tCtrls["txt"]["txt_32"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_37")] = function()
		if tCtrls["chk"]["chk_37"]:IsChecked() then
			tCtrls["chk"]["chk_34"]:Enable(false)
			tCtrls["txt"]["txt_motd"]:Enable(false)
		else
			tCtrls["chk"]["chk_34"]:Enable(true)
			tCtrls["txt"]["txt_motd"]:Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_17")] = function()
		if tCtrls["chk"]["chk_17"]:IsChecked() then
			tCtrls["txt"]["txt_22"]:Enable(true)
			tCtrls["txt"]["txt_23"]:Enable(true)
			tCtrls["chk"]["chk_18"]:Enable(true)
			if tCtrls["chk"]["chk_18"]:IsChecked() then
				tCtrls["txt"]["txt_21"]:Enable(true)
			end
		else
			tCtrls["txt"]["txt_22"]:Enable(false)
			tCtrls["txt"]["txt_23"]:Enable(false)
			tCtrls["chk"]["chk_18"]:Enable(false)
			tCtrls["txt"]["txt_21"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_19")] = function()
		if tCtrls["chk"]["chk_19"]:IsChecked() then
			tCtrls["txt"]["txt_24"]:Enable(true)
			tCtrls["txt"]["txt_25"]:Enable(true)
			tCtrls["txt"]["txt_26"]:Enable(true)
		else
			tCtrls["txt"]["txt_24"]:Enable(false)
			tCtrls["txt"]["txt_25"]:Enable(false)
			tCtrls["txt"]["txt_26"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_18")] = function()
		if not tCtrls["chk"]["chk_18"]:IsChecked() or not tCtrls["chk"]["chk_17"]:IsChecked() then
			tCtrls["txt"]["txt_21"]:Enable(false)
		else
			tCtrls["txt"]["txt_21"]:Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_7")] = function()
		if tCtrls["chk"]["chk_7"]:IsChecked() then
			tCtrls["txt"]["txt_12"]:Enable(true)
		else
			tCtrls["txt"]["txt_12"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_31")] = function()
		if tCtrls["chk"]["chk_31"]:IsChecked() then
			tCtrls["chk"]["chk_32"]:Enable(true)
		else
			tCtrls["chk"]["chk_32"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_5")] = function()
		if tCtrls["chk"]["chk_5"]:IsChecked() then
			tCtrls["chk"]["chk_6"]:Enable(true)
			tCtrls["txt"]["txt_8"]:Enable(true)
			tCtrls["txt"]["txt_9"]:Enable(true)
		else
			tCtrls["chk"]["chk_6"]:Enable(false)
			tCtrls["txt"]["txt_8"]:Enable(false)
			tCtrls["txt"]["txt_9"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_6")] = function()
		if tCtrls["chk"]["chk_6"]:IsChecked() then
			tCtrls["txt"]["txt_9"]:Enable(true)
		else
			tCtrls["txt"]["txt_9"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_20")] = function()
		if tCtrls["chk"]["chk_20"]:IsChecked() then
			tCtrls["txt"]["txt_27"]:Enable(true)
		else
			tCtrls["txt"]["txt_27"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_21")] = function()
		if tCtrls["chk"]["chk_21"]:IsChecked() then
			tCtrls["txt"]["txt_28"]:Enable(true)
		else
			tCtrls["txt"]["txt_28"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_10")] = function()
		if tCtrls["chk"]["chk_10"]:IsChecked() then
			tCtrls["txt"]["txt_18"]:Enable(true)
		else
			tCtrls["txt"]["txt_18"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_9")] = function()
		if tCtrls["chk"]["chk_9"]:IsChecked() then
			tCtrls["txt"]["txt_16"]:Enable(true)
		else
			tCtrls["txt"]["txt_16"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_8")] = function()
		if tCtrls["chk"]["chk_8"]:IsChecked() then
			tCtrls["txt"]["txt_14"]:Enable(true)
		else
			tCtrls["txt"]["txt_14"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_22")] = function()
		if not tCtrls["chk"]["chk_22"]:IsChecked() then
		    if wx.wxMessageBox(tLang.RemoteManagementWillBeUnavailableIfDisable,tLang.Attention,wx.wxICON_QUESTION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxNO then
			    tCtrls["chk"]["chk_22"]:SetValue(true)
			else
			    tCtrls["chk"]["chk_22"]:SetValue(false)
			   	tCtrls["chk"]["chk_33"]:Enable(false)
			end
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_27")] = function()
		if tCtrls["chk"]["chk_27"]:IsChecked() then
			tCtrls["chk"]["chk_28"]:Enable(true)
		else
			tCtrls["chk"]["chk_28"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_29")] = function()
		if tCtrls["chk"]["chk_29"]:IsChecked() then
			tCtrls["chk"]["chk_30"]:Enable(true)
		else
			tCtrls["chk"]["chk_30"]:Enable(false)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("chk_43")] = function()
		if not tCtrls["chk"]["chk_43"]:IsChecked() and tHubData.tMax.txt >= 36 then
			tCtrls["txt"]["txt_35"]:Enable(true)
			tCtrls["txt"]["txt_36"]:Enable(true)
		else
			tCtrls["txt"]["txt_35"]:Enable(false)
			tCtrls["txt"]["txt_36"]:Enable(false)
		end
	end,
}
tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_CHECKBOX_CLICKED,
function(event)
	if tCheckBoxEvtIds[event:GetId()] then
	    tCheckBoxEvtIds[event:GetId()]()
	end
end)

tChoiceEvtIds = {
    [tCtrls["xmlResource"].GetXRCID("num_57")] = function()
		if tCtrls["num"]["num_57"]:GetSelection() == 0 then
			tCtrls["num"]["num_54"]:Enable(false)
			tCtrls["num"]["num_55"]:Enable(false)
			tCtrls["num"]["num_56"]:Enable(false)
			tFuncs.GetCtrl("stt_sec1"):Enable(false)
		else
			tCtrls["num"]["num_54"]:Enable(true)
			tCtrls["num"]["num_55"]:Enable(true)
			tCtrls["num"]["num_56"]:Enable(true)
			tFuncs.GetCtrl("stt_sec1"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_21")] = function()
		if tCtrls["num"]["num_21"]:GetSelection() == 0 then
			tCtrls["num"]["num_19"]:Enable(false)
			tCtrls["num"]["num_20"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds1"):Enable(false)
		else
			tCtrls["num"]["num_19"]:Enable(true)
			tCtrls["num"]["num_20"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds1"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_68")] = function()
        if tCtrls["num"]["num_68"]:GetSelection() == 0 then
			tCtrls["num"]["num_66"]:Enable(false)
			tCtrls["num"]["num_67"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds2"):Enable(false)
		else
			tCtrls["num"]["num_66"]:Enable(true)
			tCtrls["num"]["num_67"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds2"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_24")] = function()
		if tCtrls["num"]["num_24"]:GetSelection() == 0 then
			tCtrls["num"]["num_22"]:Enable(false)
			tCtrls["num"]["num_23"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds4"):Enable(false)
		else
			tCtrls["num"]["num_22"]:Enable(true)
			tCtrls["num"]["num_23"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds4"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_27")] = function()
		if tCtrls["num"]["num_27"]:GetSelection() == 0 then
			tCtrls["num"]["num_25"]:Enable(false)
			tCtrls["num"]["num_26"]:Enable(false)
			tFuncs.GetCtrl("stt_with1"):Enable(false)
			tFuncs.GetCtrl("stt_lines1"):Enable(false)
		else
			tCtrls["num"]["num_25"]:Enable(true)
			tCtrls["num"]["num_26"]:Enable(true)
			tFuncs.GetCtrl("stt_with1"):Enable(true)
			tFuncs.GetCtrl("stt_lines1"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_81")] = function()
        if tCtrls["num"]["num_81"]:GetSelection() == 0 then
			tCtrls["num"]["num_79"]:Enable(false)
			tCtrls["num"]["num_80"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds5"):Enable(false)
		else
			tCtrls["num"]["num_79"]:Enable(true)
			tCtrls["num"]["num_80"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds5"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_84")] = function()
        if tCtrls["num"]["num_84"]:GetSelection() == 0 then
			tCtrls["num"]["num_82"]:Enable(false)
			tCtrls["num"]["num_83"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds6"):Enable(false)
		else
			tCtrls["num"]["num_82"]:Enable(true)
			tCtrls["num"]["num_83"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds6"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_87")] = function()
        if tCtrls["num"]["num_87"]:GetSelection() == 0 then
			tCtrls["num"]["num_85"]:Enable(false)
			tCtrls["num"]["num_86"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds7"):Enable(false)
		else
			tCtrls["num"]["num_85"]:Enable(true)
			tCtrls["num"]["num_86"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds7"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_90")] = function()
        if tCtrls["num"]["num_90"]:GetSelection() == 0 then
			tCtrls["num"]["num_88"]:Enable(false)
			tCtrls["num"]["num_89"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds8"):Enable(false)
		else
			tCtrls["num"]["num_88"]:Enable(true)
			tCtrls["num"]["num_89"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds8"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_30")] = function()
		if tCtrls["num"]["num_30"]:GetSelection() == 0 then
			tCtrls["num"]["num_28"]:Enable(false)
			tCtrls["num"]["num_29"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds9"):Enable(false)
		else
			tCtrls["num"]["num_28"]:Enable(true)
			tCtrls["num"]["num_29"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds9"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_71")] = function()
		if tCtrls["num"]["num_71"]:GetSelection() == 0 then
			tCtrls["num"]["num_69"]:Enable(false)
			tCtrls["num"]["num_70"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds10"):Enable(false)
		else
			tCtrls["num"]["num_69"]:Enable(true)
			tCtrls["num"]["num_70"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds10"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_33")] = function()
		if tCtrls["num"]["num_33"]:GetSelection() == 0 then
			tCtrls["num"]["num_31"]:Enable(false)
			tCtrls["num"]["num_32"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds12"):Enable(false)
		else
			tCtrls["num"]["num_31"]:Enable(true)
			tCtrls["num"]["num_32"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds12"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_36")] = function()
		if tCtrls["num"]["num_36"]:GetSelection() == 0 then
			tCtrls["num"]["num_34"]:Enable(false)
			tCtrls["num"]["num_35"]:Enable(false)
			tFuncs.GetCtrl("stt_with2"):Enable(false)
			tFuncs.GetCtrl("stt_lines2"):Enable(false)
		else
			tCtrls["num"]["num_34"]:Enable(true)
			tCtrls["num"]["num_35"]:Enable(true)
			tFuncs.GetCtrl("stt_with2"):Enable(true)
			tFuncs.GetCtrl("stt_lines2"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_100")] = function()
		if tCtrls["num"]["num_100"]:GetSelection() == 0 then
			tCtrls["num"]["num_101"]:Enable(false)
			tCtrls["num"]["num_102"]:Enable(false)
			tFuncs.GetCtrl("stt_kb1"):Enable(false)
			tFuncs.GetCtrl("stt_seconds13"):Enable(false)
		else
			tCtrls["num"]["num_101"]:Enable(true)
			tCtrls["num"]["num_102"]:Enable(true)
			tFuncs.GetCtrl("stt_kb1"):Enable(true)
			tFuncs.GetCtrl("stt_seconds13"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_103")] = function()
		if tCtrls["num"]["num_103"]:GetSelection() == 0 then
			tCtrls["num"]["num_104"]:Enable(false)
			tCtrls["num"]["num_105"]:Enable(false)
			tFuncs.GetCtrl("stt_kb2"):Enable(false)
			tFuncs.GetCtrl("stt_seconds14"):Enable(false)
		else
			tCtrls["num"]["num_104"]:Enable(true)
			tCtrls["num"]["num_105"]:Enable(true)
			tFuncs.GetCtrl("stt_kb2"):Enable(true)
			tFuncs.GetCtrl("stt_seconds14"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_10")] = function()
		if tCtrls["num"]["num_10"]:GetSelection() == 0 then
			tCtrls["txt"]["txt_19"]:Enable(false)
			tCtrls["txt"]["txt_20"]:Enable(false)
		elseif tCtrls["num"]["num_10"]:GetSelection() == 1 then
			tCtrls["txt"]["txt_19"]:Enable(true)
			tCtrls["txt"]["txt_20"]:Enable(false)
		else
			tCtrls["txt"]["txt_19"]:Enable(true)
			tCtrls["txt"]["txt_20"]:Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_62")]= function()
		if tCtrls["num"]["num_62"]:GetSelection() == 0 then
			tCtrls["num"]["num_63"]:Enable(false)
			tFuncs.GetCtrl("stt_passwordbftbt"):Enable(false)
			tFuncs.GetCtrl("stt_passwordhours"):Enable(false)
		elseif tCtrls["num"]["num_62"]:GetSelection() == 1 then
			tCtrls["num"]["num_63"]:Enable(false)
			tFuncs.GetCtrl("stt_passwordbftbt"):Enable(false)
			tFuncs.GetCtrl("stt_passwordhours"):Enable(false)
		else
			tCtrls["num"]["num_63"]:Enable(true)
			tFuncs.GetCtrl("stt_passwordbftbt"):Enable(true)
			tFuncs.GetCtrl("stt_passwordhours"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_39")] = function()
    	if tCtrls["num"]["num_39"]:GetSelection() == 0 then
			tCtrls["num"]["num_37"]:Enable(false)
			tCtrls["num"]["num_38"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds16"):Enable(false)
		else
			tCtrls["num"]["num_37"]:Enable(true)
			tCtrls["num"]["num_38"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds16"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_74")] = function()
		if tCtrls["num"]["num_74"]:GetSelection() == 0 then
			tCtrls["num"]["num_72"]:Enable(false)
			tCtrls["num"]["num_73"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds17"):Enable(false)
		else
			tCtrls["num"]["num_72"]:Enable(true)
			tCtrls["num"]["num_73"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds17"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_42")] = function()
        if tCtrls["num"]["num_42"]:GetSelection() == 0 then
			tCtrls["num"]["num_40"]:Enable(false)
			tCtrls["num"]["num_41"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds19"):Enable(false)
		else
			tCtrls["num"]["num_40"]:Enable(true)
			tCtrls["num"]["num_41"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds19"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_95")] = function()
		if tCtrls["num"]["num_95"]:GetSelection() == 0 then
			tCtrls["num"]["num_93"]:Enable(false)
			tCtrls["num"]["num_94"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds20"):Enable(false)
		else
			tCtrls["num"]["num_93"]:Enable(true)
			tCtrls["num"]["num_94"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds20"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_98")] = function()
		if tCtrls["num"]["num_98"]:GetSelection() == 0 then
			tCtrls["num"]["num_96"]:Enable(false)
			tCtrls["num"]["num_97"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds21"):Enable(false)
		else
			tCtrls["num"]["num_96"]:Enable(true)
			tCtrls["num"]["num_97"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds21"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_48")] = function()
		if tCtrls["num"]["num_48"]:GetSelection() == 0 then
			tCtrls["num"]["num_46"]:Enable(false)
			tCtrls["num"]["num_47"]:Enable(false)
			tFuncs.GetCtrl("stt_minutes3"):Enable(false)
		else
			tCtrls["num"]["num_46"]:Enable(true)
			tCtrls["num"]["num_47"]:Enable(true)
			tFuncs.GetCtrl("stt_minutes3"):Enable(true)
		end
	end,
	[tCtrls["xmlResource"].GetXRCID("num_45")] = function()
		if tCtrls["num"]["num_45"]:GetSelection() == 0 then
			tCtrls["num"]["num_43"]:Enable(false)
			tCtrls["num"]["num_44"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds22"):Enable(false)
		else
			tCtrls["num"]["num_43"]:Enable(true)
			tCtrls["num"]["num_44"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds22"):Enable(true)
		end
	end,
    [tCtrls["xmlResource"].GetXRCID("num_77")] = function()
		if tCtrls["num"]["num_77"]:GetSelection() == 0 then
			tCtrls["num"]["num_75"]:Enable(false)
			tCtrls["num"]["num_76"]:Enable(false)
			tFuncs.GetCtrl("stt_seconds23"):Enable(false)
		else
			tCtrls["num"]["num_75"]:Enable(true)
			tCtrls["num"]["num_76"]:Enable(true)
			tFuncs.GetCtrl("stt_seconds23"):Enable(true)
		end
	end,
}
tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_CHOICE_SELECTED,
function(event)
	if tChoiceEvtIds[event:GetId()] then
	    tChoiceEvtIds[event:GetId()]()
	end
end)

tCtrls["app"]:Connect(tCtrls["wxID_LUA_LIST"],wx.wxEVT_COMMAND_LISTBOX_DOUBLECLICKED,
function(event)
	if tCfg.DoubleClickDownload then
		if tHubData.bEntered then
			wx.wxBeginBusyCursor()
			local script = event:GetString()
			tFuncs.DownloadFile(script)
			table.insert(tData.tDeadThreads,ThreadCreate(tFuncs.FileAction,{ script,0}))
		end
	else
		event:Skip()
	end
end)

tCtrls["app"]:Connect(tCtrls["wxID_TEXTS"],wx.wxEVT_COMMAND_LISTBOX_DOUBLECLICKED,
function(event)
	if tHubData.bEntered then
	    wx.wxBeginBusyCursor()
		local textfile = event:GetString()
		tFuncs.DownloadFile(textfile..".txt")
		table.insert(tData.tDeadThreads,ThreadCreate(tFuncs.FileAction,{ textfile..".txt",1}))
	end
end)

tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_CHECKLISTBOX_TOGGLED,
function(event)
	local tCheckListBoxEvtIds = {
	[tCtrls["wxID_LUA_LIST"]] = function()
		if tCtrls["lst_scripts"]:GetString(event:GetInt()) ~= tHubData.sScriptName or tCtrls["lst_scripts"]:IsChecked(event:GetInt()) or wx.wxMessageBox(tLang.RemoteManagementWillBeUnavailableIfDisable,tLang.Attention,wx.wxICON_QUESTION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
			wx.wxBeginBusyCursor()
			tFuncs.Send("$SET 4 "..tCtrls["lst_scripts"]:GetString(event:GetInt()).." "..tostring(tCtrls["lst_scripts"]:IsChecked(event:GetInt())))
		else
			tCtrls["lst_scripts"]:Check(event:GetInt(),true)
		end
	end,
	[tCtrls["wxID_PERMISSION_LIST"]] = function()
	    if tHubData.bEntered then
		    wx.wxBeginBusyCursor()
		    tFuncs.Send("$SET 5 "..tCtrls["lst_profiles"]:GetSelection().." p "..(event:GetInt()).." "..(tCtrls["lst_permissions"]:IsChecked(event:GetInt()) and "1" or "0"))
			if tCtrls["lst_permissions"]:IsChecked(event:GetInt()) then
				tCtrls["lst_permissions"]:Check(event:GetInt(),false)
				-- Don't check it, just when the hub sends back the confirmation
			else
			    tCtrls["lst_permissions"]:Check(event:GetInt(),true)
			end
			event:Skip()
		end
	end,
	}
	if tCheckListBoxEvtIds[event:GetId()] then
	    tCheckListBoxEvtIds[event:GetId()]()
	end
end)

tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_LISTBOX_SELECTED,
function(event)
	local tListBoxEvtIds = {
	[tCtrls["wxID_LUA_LIST"]] = function()
		if tCtrls["lst_scripts"]:GetCount() == 1 then
			tFuncs.GetCtrl("wxID_LUA_UP"):Enable(false)
			tFuncs.GetCtrl("wxID_LUA_DOWN"):Enable(false)
		elseif tCtrls["lst_scripts"]:IsSelected(0) then
			tFuncs.GetCtrl("wxID_LUA_DOWN"):Enable(true)
			tFuncs.GetCtrl("wxID_LUA_UP"):Enable(false)
		elseif tCtrls["lst_scripts"]:IsSelected(tCtrls["lst_scripts"]:GetCount()-1) then
			tFuncs.GetCtrl("wxID_LUA_UP"):Enable(true)
			tFuncs.GetCtrl("wxID_LUA_DOWN"):Enable(false)
		else
			tFuncs.GetCtrl("wxID_LUA_UP"):Enable(true)
			tFuncs.GetCtrl("wxID_LUA_DOWN"):Enable(true)
		end
	end,
	[tCtrls["wxID_PROFLIST"]] = function()
		local sel = event:GetSelection()
		tFuncs.GetCtrl("wxID_PROFLIST"):Select(sel)
	    tFuncs.LoadPermissions(sel)
		if tCtrls["lst_profiles"]:GetCount() == 1 then
			tFuncs.GetCtrl("wxID_PROF_UP"):Enable(false)
			tFuncs.GetCtrl("wxID_PROF_DOWN"):Enable(false)
		elseif tCtrls["lst_profiles"]:IsSelected(0) then
			tFuncs.GetCtrl("wxID_PROF_DOWN"):Enable(true)
			tFuncs.GetCtrl("wxID_PROF_UP"):Enable(false)
		elseif tCtrls["lst_profiles"]:IsSelected(tCtrls["lst_profiles"]:GetCount()-1) then
			tFuncs.GetCtrl("wxID_PROF_UP"):Enable(true)
			tFuncs.GetCtrl("wxID_PROF_DOWN"):Enable(false)
		else
			tFuncs.GetCtrl("wxID_PROF_UP"):Enable(true)
			tFuncs.GetCtrl("wxID_PROF_DOWN"):Enable(true)
		end
	end,
	}
	if tListBoxEvtIds[event:GetId()] then
	    tListBoxEvtIds[event:GetId()]()
	end
end)

tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_CONTEXT_MENU,
function(event)
	local tContextMenuEvtIds = {
	[tCtrls["wxID_LUA_LIST"]] = function()
		if tCtrls["lst_scripts"]:GetStringSelection() ~= "" then
			local Menu = wx.wxMenu()
			Menu:Append(tCtrls["wxID_MENU_LUA_OPEN"],tLang.OpenExternalEditor)
			Menu:Append(tCtrls["wxID_MENU_LUA_RESTART"],tLang.RestartScript)
			Menu:AppendSeparator()
			Menu:Append(tCtrls["wxID_MENU_LUA_SAVE"],tLang.SaveScript.." "..tCtrls["lst_scripts"]:GetStringSelection())
			Menu:Append(tCtrls["wxID_MENU_LUA_LOAD"],tLang.LoadScript.." "..tCtrls["lst_scripts"]:GetStringSelection())
			Menu:Append(tCtrls["wxID_MENU_LUA_DEL"],tLang.DeleteScript.." "..tCtrls["lst_scripts"]:GetStringSelection())
			tCtrls["lst_scripts"]:PopupMenu(Menu)
		end
	end,
	[tCtrls["wxID_REGLIST"]] = function()
		if tCtrls["lst_regs"]:GetSelectedItemCount() ~= 0 then
			local Menu = wx.wxMenu()
			Menu:Append(tCtrls["wxID_MENU_REG_DEL"],tLang.Remove)
			Menu:Append(tCtrls["wxID_MENU_REG_MOD"],tLang.Change)
			tCtrls["lst_regs"]:PopupMenu(Menu)
		end
	end,
	[tCtrls["wxID_BANLIST"]] = function()
		if tCtrls["lst_bans"]:GetSelectedItemCount() ~= 0 then
			local Menu = wx.wxMenu()
			local mod = Menu:Append(tCtrls["wxID_MENU_MOD_BAN"],tLang.Change)
			if tCtrls["lst_bans"]:GetSelectedItemCount() > 1 then mod:Enable(false) end
			Menu:AppendSeparator()
			Menu:Append(tCtrls["wxID_MENU_DEL_BAN"],tLang.Remove)
			tCtrls["lst_bans"]:PopupMenu(Menu)
		end
	end,
	[tCtrls["wxID_RANGEBANLIST"]] = function()
		if tCtrls["lst_rangebans"]:GetSelectedItemCount() ~= 0 then
			local Menu = wx.wxMenu()
			local mod = Menu:Append(tCtrls["wxID_MENU_MOD_RANGEBAN"],tLang.Change)
			if tCtrls["lst_rangebans"]:GetSelectedItemCount() > 1 then mod:Enable(false) end
			Menu:AppendSeparator()
			Menu:Append(tCtrls["wxID_MENU_DEL_RANGEBAN"],tLang.Remove)
			tCtrls["lst_rangebans"]:PopupMenu(Menu)
		end
	end,
	[tCtrls["wxID_TEXTS"]] = function()
	    if tCtrls["lst_texts"]:GetSelection() ~= -1 then
			local Menu = wx.wxMenu()
			Menu:Append(tCtrls["wxID_MENU_LOAD_TXT"],tLang.LoadFile.." "..tCtrls["lst_texts"]:GetStringSelection())
			Menu:Append(tCtrls["wxID_MENU_SAVE_TXT"],tLang.SaveFile.." "..tCtrls["lst_texts"]:GetStringSelection())
			Menu:Append(tCtrls["wxID_MENU_TEXT_DEL"],tLang.DeleteFile.." "..tCtrls["lst_texts"]:GetStringSelection())
			tCtrls["lst_texts"]:PopupMenu(Menu)
		end
	end,
	}
	local id = event:GetId()
	if event:GetId() == -212 then event:SetId(tCtrls["wxID_BANLIST"]) end -- Don't ask me why...
	if event:GetId() == -215 then event:SetId(tCtrls["wxID_RANGEBANLIST"]) end
	if tContextMenuEvtIds[event:GetId()] then
	    tContextMenuEvtIds[event:GetId()]()
	else
		-- -             
		event:Skip()
	end
end)

tCtrls["mainchat"]:Connect(wx.wxID_ANY,wx.wxEVT_CONTEXT_MENU,
function(event)
	local menu = wx.wxMenu()
	menu:Append(wx.wxID_COPY,tLang.Copy)
	menu:AppendSeparator()
	menu:Append(wx.wxID_SELECTALL,tLang.SelectAll)
	tCtrls["mainchat"]:PopupMenu(menu)
end)

tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_MENU_SELECTED,
function(event)
	local tMenuEvtIds = {
	[tCtrls["ID_MAINMENU_EXIT"]] = tFuncs.Exit,
	[tCtrls["ID_MAINMENU_SETTINGS"]] = tDialogs.Settings,
	[tCtrls["ID_MAINMENU_RELOADSTYLE"]] = function()
		if tEditor then
			tEditor.SetStyle()
		end
	end,
	[tCtrls["ID_MAINMENU_UDPDBG"]] = function()
		if tCfg.UDPDebug then
			tFuncs.UDPDebugClose()
			tCfg.UDPDebug = false
			tCtrls["MAINMENU_UDPDBG"]:Check(false)
		else
			tFuncs.UDPDebugOpen()
			tCfg.UDPDebug = true
			tCtrls["MAINMENU_UDPDBG"]:Check(true)
		end
		tFuncs.UDPDebugEnable()
	end,
	[tCtrls["ID_MAINMENU_SCRIPTERRORS"]] = function()
		if tCfg.ScriptErrors then
			tCfg.ScriptErrors = false
			tCtrls["MAINMENU_SCRIPTERRORS"]:Check(false)
		else
			tCfg.ScriptErrors = true
			tCtrls["MAINMENU_SCRIPTERRORS"]:Check(true)
		end
		tFuncs.UDPDebugEnable()
	end,
	[tCtrls["ID_MAINMENU_ABOUT"]] = tDialogs.About,
	[tCtrls["ID_MAINMENU_HOMEPAGE"]] = function()
		if wx.__WXMSW__ then
			process.exec("http://mydc.ru/topic2131.html","",1)
		end
	end,
	[tCtrls["wxID_MENU_LUA_OPEN"]] = function()
		local script = tCtrls["lst_scripts"]:GetStringSelection()
	    tFuncs.DownloadFile(script)
		table.insert(tData.tDeadThreads,ThreadCreate(tFuncs.FileAction,{tCtrls["lst_scripts"]:GetStringSelection(),3}))
	end,
	[tCtrls["wxID_MENU_LUA_RESTART"]] = function()
	    if tCtrls["lst_scripts"]:IsChecked(tCtrls["lst_scripts"]:GetSelection()) then
			tFuncs.Send("$RSS "..tCtrls["lst_scripts"]:GetStringSelection())
		end
	end,
	[tCtrls["wxID_MENU_LUA_LOAD"]] = function()
	    local filename = tCtrls["lst_scripts"]:GetStringSelection()
		tFuncs.DownloadFile(filename)
		table.insert(tData.tDeadThreads,ThreadCreate(tFuncs.FileAction,{ filename, 0}))
	end,
	[tCtrls["wxID_MENU_LUA_SAVE"]] = function()
		if tHubData.bEntered then
			local filename = tCtrls["lst_scripts"]:GetStringSelection()
			if not wx.wxDirExists(_save_path.."scripts") then wx.wxMkdir(_save_path.."scripts") end
			local f = io.open(_save_path.."scripts/"..filename,"wb")
			if f then
				local c = ""
				if tEditor then
					c = editor:GetText()
				else
					c = editor:GetValue()
				end
				f:write(c)
				tFuncs.Send("$SET 7 "..filename..":"..c)
			end
		end
	end,
	[tCtrls["wxID_MENU_LUA_DEL"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
			local name = tCtrls["lst_scripts"]:GetStringSelection()
			tFuncs.Send("$SET 7 "..name..":del")
            tCtrls["lst_scripts"]:Delete(tCtrls["lst_scripts"]:GetSelection())
			tCtrls["tScripts"][name] = nil
		end
	end,
	[tCtrls["wxID_MENU_REG_MOD"]] = function()
		local item = tFuncs.GetSelection(tCtrls["lst_regs"])
		local iPos = tCtrls["lst_regs"]:GetItemData(item)+1
		local onick = tCtrls["lst_regs"]:GetItemText(item)
		local nick,pass,profile = tDialogs.RegUser(tHubData.tRegs[iPos][1],tHubData.tRegs[iPos][2],tHubData.tRegs[iPos][3])
		if nick then -- if not cancelled
			if nick == onick then
				tFuncs.Send("$SET 6 2 "..nick.." "..pass.." "..profile)
			else
				tCtrls["lst_regs"]:DeleteItem(item)
			    tFuncs.Send("$SET 6 1 "..nick.." "..pass.." "..profile)
			end
		end
	end,
	[tCtrls["wxID_MENU_REG_DEL"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
			local item = tFuncs.GetSelection(tCtrls["lst_regs"])
			local nick = tCtrls["lst_regs"]:GetItemText(item)
			if nick ~= tData.CurrentHub.Nick or wx.wxMessageBox(tLang.DelSelfAccountMsg,tLang.Attention,wx.wxICON_EXCLAMATION+wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then 
				tFuncs.Send("$SET 6 0 "..nick)
			end
		end
	end,
	[tCtrls["wxID_MENU_MOD_BAN"]] = function()
		local item = tFuncs.GetSelection(tCtrls["lst_bans"])
		local tBan = tDialogs.Ban(tHubData.tBans[tCtrls["lst_bans"]:GetItemData(item)+1])
		if not tBan then return end
		if tBan[1] then tFuncs.Unban(item) end
		tFuncs.CreateBan(tBan[2])
	end,
	[tCtrls["wxID_MENU_DEL_BAN"]] = function()
	    wx.wxBeginBusyCursor()
		local item = tCtrls["lst_bans"]:GetNextItem(-1,wx.wxLIST_NEXT_ALL,wx.wxLIST_STATE_SELECTED)
		while item ~= -1 do
			-- GetItemData give back the selected items data to avoid re-sorted list's wrong indexes
			tFuncs.Unban(item)
			item = tCtrls["lst_bans"]:GetNextItem(item,wx.wxLIST_NEXT_ALL,wx.wxLIST_STATE_SELECTED)
		end
	end,
	[tCtrls["wxID_MENU_MOD_RANGEBAN"]] = function()
		local item = tFuncs.GetSelection(tCtrls["lst_rangebans"])
		local tBan = tDialogs.RangeBan(tHubData.tRangeBans[tCtrls["lst_rangebans"]:GetItemData(item)+1])
		if not tBan then return end
		if tBan[1] then
			tFuncs.Send("$SET 3 3 "..item.." "..tHubData.tRangeBans[item+1][1])
		end
		tFuncs.CreateRangeBan(tBan[2])
	end,
	[tCtrls["wxID_MENU_DEL_RANGEBAN"]] = function()
	    wx.wxBeginBusyCursor()
	    local item = tCtrls["lst_rangebans"]:GetNextItem(-1,wx.wxLIST_NEXT_ALL,wx.wxLIST_STATE_SELECTED)
	    while item ~= -1 do
	        -- GetItemData give back the selected items data to avoid re-sorted list's wrong indexes
	        local selitem = tCtrls["lst_rangebans"]:GetItemData(item)
			tFuncs.Send("$SET 3 3 "..selitem.." "..tHubData.tRangeBans[selitem+1][1])
			item = tCtrls["lst_rangebans"]:GetNextItem(item,wx.wxLIST_NEXT_ALL,wx.wxLIST_STATE_SELECTED)
		end
	end,
	[tCtrls["wxID_MENU_LOAD_TXT"]] = function()
	    if tHubData.bEntered then
		    wx.wxBeginBusyCursor()
			local textfile = tCtrls["lst_texts"]:GetStringSelection()
			-- The program will always download the selected file
			tFuncs.DownloadFile(textfile..".txt")
			table.insert(tData.tDeadThreads,ThreadCreate(tFuncs.FileAction,{ textfile..".txt",1}))
		end
	end,
	[tCtrls["wxID_MENU_SAVE_TXT"]] = function()
		if tHubData.bEntered then
			local filename = tCtrls["lst_texts"]:GetStringSelection()
			if not wx.wxDirExists(_save_path.."texts") then wx.wxMkdir(_save_path.."texts") end
			local f = io.open(_save_path.."texts/"..filename..".txt","wb")
			if f then
				local c = tFuncs.GetCtrl("txt_texteditor"):GetValue():gsub("|","[endpipe]")
				f:write(c)
				f:close()
				tFuncs.Send("$SET 7 "..filename..".txt:"..c)
			end
		end
	end,
	[tCtrls["wxID_MENU_TEXT_DEL"]] = function()
	    if tHubData.bEntered and wx.wxMessageBox(tLang.AreYouSure.."?",_APPNAME,wx.wxYES_NO+wx.wxNO_DEFAULT) == wx.wxYES then
			tFuncs.Send("$SET 7 "..tCtrls["lst_texts"]:GetStringSelection()..".txt:del")
			tFuncs.ReloadTexts()
		end
	end,
	}
	if tMenuEvtIds[event:GetId()] then
	    tMenuEvtIds[event:GetId()]()
	end
end)

tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_LIST_ITEM_ACTIVATED,
function(event)
	local tActivateEvtIds = {
	[tCtrls["wxID_REGLIST"]] = function()
		local item = tFuncs.GetSelection(tCtrls["lst_regs"])
		local iPos = tCtrls["lst_regs"]:GetItemData(item)+1
		local onick = tCtrls["lst_regs"]:GetItemText(item)
		local nick,pass,profile = tDialogs.RegUser(tHubData.tRegs[iPos][1],tHubData.tRegs[iPos][2],tHubData.tRegs[iPos][3])
		if nick then -- if not cancelled
			if nick == onick then
				tFuncs.Send("$SET 6 2 "..nick.." "..pass.." "..profile)
			else
				tCtrls["lst_regs"]:DeleteItem(item)
			    tFuncs.Send("$SET 6 1 "..nick.." "..pass.." "..profile)
			end
		end
	end,
	[tCtrls["wxID_BANLIST"]] = function()
		local item = tFuncs.GetSelection(tCtrls["lst_bans"])
		local tBan = tDialogs.Ban(tHubData.tBans[tCtrls["lst_bans"]:GetItemData(item)+1],tCtrls["lst_bans"]:GetItemData(item))
		if not tBan then return end
		if tBan[1] then tFuncs.Unban(item) end
		tFuncs.CreateBan(tBan[2])
	end,
	[tCtrls["wxID_RANGEBANLIST"]] = function()
		local item = tFuncs.GetSelection(tCtrls["lst_rangebans"])
		local tBan = tDialogs.RangeBan(tHubData.tRangeBans[tCtrls["lst_rangebans"]:GetItemData(item)+1])
		if not tBan then return end
		if tBan[1] then
			tFuncs.Send("$SET 3 3 "..item.." "..tHubData.tRangeBans[item+1][1])
		end
		tFuncs.CreateRangeBan(tBan[2])
	end,}
	if tActivateEvtIds[event:GetId()] then
	    tActivateEvtIds[event:GetId()]()
	end
end)

tCtrls["app"]:Connect(wx.wxID_ANY,wx.wxEVT_COMMAND_LIST_COL_CLICK,
function(event)
	local tColumnEvtIds = {
	[tCtrls["wxID_REGLIST"]] = function()
    	tFuncs.SortListItems(event:GetColumn(),"lst_regs")
	end,
	[tCtrls["wxID_BANLIST"]] = function()
	    tFuncs.SortListItems(event:GetColumn(),"lst_bans")
	end,
	[tCtrls["wxID_RANGEBANLIST"]] = function()
	    tFuncs.SortListItems(event:GetColumn(),"lst_rangebans")
	end,
	}
	if tColumnEvtIds[event:GetId()] and tHubData.bEntered then
	    tColumnEvtIds[event:GetId()]()
	end
end)

tCtrls["app"]:Connect(tCtrls["xmlResource"].GetXRCID("txt_chat_msg"),wx.wxEVT_COMMAND_TEXT_ENTER, -- Called when F1 pressed
function(event)
	if tHubData.bEntered then
		tFuncs.Send("<"..tData.CurrentHub.Nick.."> "..(tCtrls["mainchat_msg"]:GetValue()):gsub("|","&#124;"))
		tCtrls["mainchat_msg"]:SetValue("")
	end
end)

-- Called when F1 pressed
tCtrls["app"]:Connect(wx.wxEVT_HELP,function(event)
	tDialogs.About()
end)

if wx.__WXMSW__ and tData.TrayIcon then -- On Unix it hides the program...
	tCtrls["app"]:Connect(wx.wxEVT_ICONIZE,
	function(event)
		if tCfg.MinToTray then	
			tCtrls["sash2pos"] = tFuncs.GetCtrl("ID_SPLITTERWINDOW2"):GetSashPosition()
			tCtrls["app"]:Iconize(true)
			tCtrls["app"]:Show(false)
		end
	end)
	tCtrls["taskbar"]:Connect(wx.wxID_ANY,wx.wxEVT_TASKBAR_LEFT_DOWN,
	function(event)
		if tCtrls["app"]:IsIconized() then
			tCtrls["app"]:Show(true)
			tCtrls["app"]:Iconize(false)
			if tCtrls["sash2pos"] then
				tFuncs.GetCtrl("ID_SPLITTERWINDOW2"):SetSashPosition(tCtrls["sash2pos"])
				tCtrls["sash2pos"] = nil
			end
		else
			tCtrls["sash2pos"] = tFuncs.GetCtrl("ID_SPLITTERWINDOW2"):GetSashPosition()
			tCtrls["app"]:Iconize(true)
			if tCfg.MinToTray then
				tCtrls["app"]:Show(false)
			end
		end
	end)
end

tCtrls["app"]:Connect(wx.wxEVT_CLOSE_WINDOW,tFuncs.Exit)
