--[[##################################################################################

	PXControl by alex82
	Based on Ptokax Remote Administration by Hungarista

####################################################################################

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

###################################################################################]]

TranslateGUI = function()
	local tTranslate = {
		STATIC_LOGIN = "Conection", stt_hub = "Hub", wxID_CMD_LOGIN = "Connection", wxID_CMD_ADDHUB = "New", wxID_CMD_MODHUB = "Change", wxID_CMD_DELHUB = "Remove",
		STATIC_STATS = "Stats", ID_CMD_CLIPBOARD = "Copy", ID_CMD_REFRESH = "Refresh",
		wxID_CLEAR_EDITOR = "ClearEditor", wxID_CLEAR_ERROR = "ClearErrors", stb_ip2cmanager = "IP2CManager"
	}
	for i,v in pairs(tTranslate) do
		if rawget(tLang,v) then tFuncs.GetCtrl(i):SetLabel(rawget(tLang,v)) end
	end
	
	-- Hub tab
	tCtrls["tab"]:SetPageText(0,tLang.Hub)
	tFuncs.GetCtrl("ID_PNL_LOGIN"):Layout()
	local nb_stats = tFuncs.GetCtrl("NB_STATS")
	nb_stats:SetPageText(0,tLang.Main)
	nb_stats:SetPageText(1,tLang.CMDs)
	nb_stats:SetPageText(2,tLang.HardwareAndNetwork)
	
	-- Settings tab
	tCtrls["tab"]:SetPageText(1,tLang.Settings)
	
	local item = tCtrls["settings_tree"]:GetFirstVisibleItem()
	local Next = function() item = tCtrls["settings_tree"]:GetNextVisible(item) end
	if not wx.__WXMSW__ then Next() end
	tCtrls["settings_tree"]:SetItemText(item,tLang.GeneralSettings) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.MOTD) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.DefaultBots) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.MoreGeneral) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.BanHandling) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.Advanced) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.MyinfoProcess) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.Rules) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.MoreRules) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.Deflood) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.MoreDeflood) Next()
	tCtrls["settings_tree"]:SetItemText(item,tLang.MoreMoreDeflood) Next()

	-- Checkboxes
	for i, v in pairs({
		[0] = "AntiMoGLODescription",
		[1] = "HubAutoStart",
		[2] = "RedirectAllConn",
		[3] = "RedirectFull",
		[4] = "AutoReg",
		[5] = "AllowOnlyRegs",
		[6] = "EnableWithArrow",
		[7] = "EnableWithArrow",
		[8] = "EnableWithArrow",
		[9] = "EnableWithArrow",
		[10] = "EnableWithArrow",
		[11] = "ModeToMyINFO",
		[12] = "ModeToDescr",
		[13] = "RemoveDescription",
		[14] = "RemoveTag",
		[15] = "RemoveConnection",
		[16] = "RemoveEmail",
		[17] = "EnableAndRegBotOnHub",
		[18] = "UseAsAlias",
		[19] = "EnableAndRegBotOnHub",
		[20] = "EnableWithArrow",
		[21] = "EnableWithArrow",
		[22] = "EnableScripting",
		[23] = "KeepSlow",
		[24] = "CheckStartupNewVersion",
		[25] = "EnableTray",
		[26] = "MinimizeOnStartup",
		[27] = "FilterKicks",
		[28] = "FilteredKicksToOPs",
		[29] = "SendStatus",
		[30] = "SendStatusPm",
		[31] = "EnableTextFiles",
		[32] = "TextFilesPm",
		[33] = "StopScriptError",
		[34] = "SendMOTDinPM",
		[35] = "ReportFlood",
		[36] = "ReplyHubCmdsPm",
		[37] = "DisableMOTD",
		[38] = "DisallowPingers",
		[39] = "ReportPingers",
		[40] = "ReportBadPass",
		[41] = "AdvPassProtect",
		[42] = "ListenOnlyOnIPs",
		[43] = "ResolveHostToIPs",
		[44] = "EnableWithArrow",
		[46] = "ShowBannedIP",
		[47] = "ShowBannedRange",
		[48] = "ShowBannedNick",
		[49] = "ShowReason",
		[50] = "ShowWho",
		[51] = "ReportBadTags",
		[55] = "LogScriptErrors",
		[57] = "ShowWelcomeMessage",
		[58] = "BlockUnknownCommands",
		[59] = "CheckKeys",
		[60] = "UseCompression",
		[61] = "ScriptErrorsToOps",
		[62] = "ScriptStackTraceback",
		[63] = "KeepMagicByte",
	}) do
		if rawget(tLang,v) then tCtrls["chk"]["chk_"..i]:SetLabel(rawget(tLang,v)) end
	end

	-- Labels
	for i, v in pairs({
		-- 1. General settings
		stb_language = "Language", stb_maxusers = "MaxUsersLimit", stb_hubname = "HubName", stb_hubtopic = "HubTopic",
		stb_hubdesc = "HubDescription", stb_hubaddress = "HubAddress", stb_ipv4addr = "IPv4Address", stb_ipv6addr = "IPv6Address",
		stb_tcp = "TCPPorts", stb_udp = "UDPPort", stb_adminnick = "AdminNick", stb_hublistregs = "HublistRegisterAddresses",
		-- 2. Advanced
		stb_hubstartup = "HubStartupAndTrayIcon", stb_hubcommands = "HubCommands", stt_cmdprefixes = "PrefixesForHubCmds",
		stb_scripting = "Scripting", stb_kickmessages = "KickMessages", stb_statusmessages = "StatusMessages", stb_welcome = "Welcome",
		-- 3. Rules
		stb_nicklimits = "NickLimits", stt_minnicklen = "MinLen", stt_maxnicklen = "MaxLen", stb_nicklimitmsg = "Message",
		stb_nicklimitredirect = "RedirectAddress", stb_sharelimits = "ShareLimits", stt_minshare = "MinShare",
		stt_maxshare = "MaxShare", stb_sharelimitmsg = "Message", stb_sharelimitredirect = "RedirectAddress",
		-- 4. DeFlood
		stb_defloodglobal = "GlobalMainChatDeflood", stt_sec1 = "SecLwr", stt_for = "For", stt_sec2 = "SecLwr",
		stb_defloodmain = "MainChat", stt_interval1 = "Interval", stb_defloodmainsame = "SameMainChat",
		stb_defloodmainsameml = "SameMultiMainChat", stt_with1 = "WithLwr", stt_lines1 = "LinesLwr",
		stb_defloodmainlimits = "MainChatLimits", stt_limit_length1 = "Length", stt_limit_lines1 = "Lines",
		stb_defloodtempban = "DefloodTempBanTime", stt_minutes1 = "MinutesLwr", stb_defloodmaxuserlogins = "MaxUsersLogins",
		stt_per10sec = "Per10Seconds", stb_defloodctmlen = "ConnectToMeLenLimit", stt_max1 = "Maximum",
		stb_defloodrctmlen = "RevConnectToMeLenLimit", stt_max2 = "Maximum",
		-- 5. MOTD
		stb_motd = "MOTD(motd)",
		-- 6. Default bots
		stb_hubbot = "HubBot", stb_hubbotnick = "Nick", stb_hubbotdesc = "Description", stb_hubbotemail = "Email",
		stb_opchat = "OpChatBot", stb_opchatnick = "Nick", stb_opchatdesc = "Description", stb_opchatemail = "Email",
		-- 7. More general
		stb_textfiles = "TextFiles", stb_pinger = "Pinger", stb_hubowneremail = "HubOwnerEmail",
		stb_mainrediraddr = "MainRedirectAddress", stb_regonlyhub = "RegOnlyHub", stb_regonlymsg = "RegOnlyMsg",
		stb_regonlyrediraddr = "RedirectAddress", stb_experts = "ExpertsOnly",
		-- 8. Ban handling
		stb_defaulttempban = "TempBanTimeAfterEtc", stt_minutes2 = "MinutesLwr", stb_banmessage = "BanMessage",
		stb_banmsgaddmsg = "AddMsg", stb_tempbanrediraddr = "TempBanRedirAddress", stb_permbanrediraddr = "PermBanRedirAddress",
		stb_passwordprot = "PasswordProtection", stb_passwordbruteforce = "BruteForcePassProtAct",
		stt_passwordbftbt = "TemporaryBanTime", stt_passwordhours = "HoursLwr",
		-- 9. MyINFO processing
		stb_myinfoprocessing = "MyinfoProcess", stt_myinfosendminutes = "DontSendMyINFOChanges", stb_desctag = "DescriptionTag",
		stb_userwotag = "NoTagAction", stb_userwotagmsg = "Message", stb_userwotagrediraddr = "RedirectAddress",
		stt_sendlongmyinfo = "SendLongMyinfos", stb_shortmyinfooptions = "OptionsForShortMyINFO",
		-- 10. More rules
		stb_hubslimits = "MaximalHubsLimit", stt_maxhubs = "MaxHubs", stb_maxhubsmsg = "Message",
		stb_maxhubsredirect = "RedirectAddress", stb_slotslimits = "SlotLimits", stt_minslots = "MinSlots",
		stt_maxslots = "MaxSlots", stb_slotsmsg = "Message", stb_slotsredirect = "RedirectAddress",
		stb_hubslotslimits = "HubSlotRatioLimit", stt_hubslothubs = "Hubs", stt_hubslotslots = "Slots",
		stb_hubslotsmsg = "Message", stb_hubslotsredirect = "RedirectAddress", stb_defloodctm = "ConnectToMe",
		stb_defloodrctm = "RevConnectToMe",
		-- 11. More deflood
		stb_defloodprivate = "PrivateMessages", stt_interval2 = "Interval", stb_defloodprivatesame = "SamePrivateMessages",
		stb_deflood_privatesameml = "SameMultiPrivateMessages", stt_with2 = "WithLwr", stt_lines2 = "LinesLwr",
		stb_defloodprivperuser = "PMLimToUsrFrmMultiNicks", stt_defloodmaxmsgs = "MaxMsgsToOneUserPerMin",
		stb_defloodreceiveddata = "RecvDataFromUser", stb_defloodwarns = "WarnSettings", stt_after = "After",
		stt_warnings = "Warnings", stb_defloodnewconnsameip = "NewConnsFrmSingleIPLim", stb_defloodprivatelimits = "PMLimits",
		stt_limit_length2 = "Length", stt_limit_lines2 = "Lines", stb_defloodmaxusersfromsameip = "MaxUsersSameIP",
		stb_defloodreconntime = "ReConnTime", stt_min = "Minimum", stt_sec3 = "SecLwr",
		-- 12. More more deflood
		stb_defloodsearch = "Search", stt_interval3 = "Interval", stb_defloodsearchsame = "SameSearches", stb_searchreply = "SR",
		stb_defloodmaxsr = "PSRLimit", stb_defloodgetnicklist = "GetNickLists", stt_minutes3 = "MinutesLwr",
		stb_defloodmyinfo = "MyINFOs", stb_defloodsearchlimits = "SearchLengthLimits", stt_minimum = "Minimum", stt_max3 = "Maximum",
		stb_defloodsrlimit = "SRLenLimit", stt_max4 = "Maximum", stb_defloodmyinfolimit = "MyINFOLengthLimit", stt_max5 = "Maximum",

		REFRESH = "Refresh", ACCEPT = "Accept", IP2C_UPLOADV4 = "IP2CUploadIPv4", IP2C_UPLOADV6 = "IP2CUploadIPv6", IP2C_RELOAD = "IP2CReload",
		-- Scripts tab
		LUA_REFRESH = "RefreshList", LUA_UP = "MoveUp", LUA_DOWN = "MoveDown", LUA_MEMORY = "MemUsage",
		LUA_RESTART = "RestartScripts", LUA_LOAD = "Load", LUA_SAVE = "Save", LUA_NEW = "New", LUA_UPLOAD = "Upload",
		-- Registered users tab
		stb_regusers = "RegUsers", REG_RELOAD = "RefreshList", REG_ADD = "New", REG_MOD = "Change", REG_DEL = "Remove",
		PROF_RELOAD = "RefreshList", stb_profman = "ProfileManager", PROF_ALL = "SetAll", PROF_CLEAR = "ClearAll",
		PROF_UP = "MoveUp",PROF_DOWN = "MoveDown", PROF_ADD = "Add", PROF_DEL = "Remove", stb_profperm = "ProfilePermissions",
		
		-- Bans tab
		ADD_BAN = "AddNewBan", REFRESH_BANS = "RefreshList", CLEAR_TB = "ClearTempBans", CLEAR_PB = "ClearPermBans",
		ADD_RANGEBAN = "AddNewRangeBan", REFRESH_RANGEBANS = "RefreshList", CLEAR_TRB = "ClearTempRangeBans", CLEAR_PRB = "ClearPermRangeBans",
		-- Texts tab
		TEXT_RELOADLIST = "RefreshList", TEXT_RELOAD = "ReloadFiles", TEXT_LOAD = "Load", TEXT_SAVE = "Save",
		TEXT_NEW = "New", TEXT_UPLOAD = "Upload",
	}) do
--		if not tCtrls[i] then wx.wxMessageBox(i) end
		if rawget(tLang,v) then tCtrls[i]:SetLabel(rawget(tLang,v)) end
	end
	
	-- Seconds labels
	for i = 1, 23 do
		tCtrls["stt_seconds"..i]:SetLabel(tLang.SecondsLwr)
	end

	-- Text tooltips
	tCtrls["txt"]["txt_3"]:SetToolTip(tLang.TCPPortsHint)
	tCtrls["txt"]["txt_7"]:SetToolTip(tLang.HubListRegsHint)
	tCtrls["txt"]["txt_9"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_11"]:SetToolTip(tLang.ShareLimitMessageHint)
	tCtrls["txt"]["txt_12"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_13"]:SetToolTip(tLang.SlotLimitMessageHint)
	tCtrls["txt"]["txt_14"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_15"]:SetToolTip(tLang.HubSlotRatioMessageHint)
	tCtrls["txt"]["txt_16"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_17"]:SetToolTip(tLang.HubLimitMessageHint)
	tCtrls["txt"]["txt_18"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_20"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_27"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_28"]:SetToolTip(tLang.RedirectHint)
	tCtrls["txt"]["txt_31"]:SetToolTip(tLang.NickLimitMessageHint)
	tCtrls["txt"]["txt_32"]:SetToolTip(tLang.RedirectHint)

	-- 1. General settings
	tFuncs.GetCtrl("ID_PANEL1"):Layout()
	-- 2. Advanced
	tFuncs.GetCtrl("ID_PANEL2"):Layout()
	-- 3. Rules
	tCtrls["num"]["num_60"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_61"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_1"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_3"]:SetToolTip(tLang.ZeroUnlimited)
	tFuncs.GetCtrl("ID_PANEL3"):Layout()
	-- 4. DeFlood
	local tActions = {
		tLang.Disabled,
		tLang.Ignore,
		tLang.Warn,
		tLang.Disconnect,
		tLang.Kick,
		tLang.TempBan,
		tLang.PermBan,
	}
	local tGlobal = {
		tLang.Disabled,
		tLang.LockChat,
		tLang.OnlyToOPsWithIP,
	}
	local TranslateComboBox = function(combo)
		local i = combo:GetSelection(); combo:Clear(); combo:Append(tActions); combo:SetSelection(i)
	end
	TranslateComboBox(tCtrls["num"]["num_21"])
	TranslateComboBox(tCtrls["num"]["num_68"])
	TranslateComboBox(tCtrls["num"]["num_24"])
	TranslateComboBox(tCtrls["num"]["num_27"])
	TranslateComboBox(tCtrls["num"]["num_81"])
	TranslateComboBox(tCtrls["num"]["num_84"])
	TranslateComboBox(tCtrls["num"]["num_87"])
	TranslateComboBox(tCtrls["num"]["num_90"])
	local i = tCtrls["num"]["num_57"]:GetSelection()
	tCtrls["num"]["num_57"]:Clear()
	tCtrls["num"]["num_57"]:Append(tGlobal)
	tCtrls["num"]["num_57"]:SetSelection(0)
	tFuncs.GetCtrl("ID_PANEL4"):Layout()
	-- 5. MOTD
	tFuncs.GetCtrl("ID_PANEL5"):Layout()
	-- 6. Default bots
	tFuncs.GetCtrl("ID_PANEL6"):Layout()
	-- 7. More general
	tFuncs.GetCtrl("ID_PANEL7"):Layout()
	-- 8. Ban handling
	local tActions = {tLang.Disabled,tLang.PermBan,tLang.TempBan}
	local i = tCtrls["num"]["num_62"]:GetSelection()
	tCtrls["num"]["num_62"]:Clear()
	tCtrls["num"]["num_62"]:Append(tActions)
	tCtrls["num"]["num_62"]:SetSelection(i)
	tFuncs.GetCtrl("ID_PANEL8"):Layout()
	-- 9. MyINFO processing
	local tmyinfotosend = {tLang.ToAllUsers,tLang.OnlyAllowedProfiles,tLang.DontSend}
	local i = tCtrls["num"]["num_11"]:GetSelection()
	tCtrls["num"]["num_11"]:Clear()
	tCtrls["num"]["num_11"]:Append(tmyinfotosend)
	tCtrls["num"]["num_11"]:SetSelection(i)
	tCtrls["num"]["num_11"]:SetToolTip(tLang.MyINFOToHint)
	local tActions = {tLang.Accept,tLang.Reject,tLang.Redir}
	local i = tCtrls["num"]["num_10"]:GetSelection()
	tCtrls["num"]["num_10"]:Clear()
	tCtrls["num"]["num_10"]:Append(tActions)
	tCtrls["num"]["num_10"]:SetSelection(i)
	tFuncs.GetCtrl("ID_PANEL9"):Layout()
	-- 10. More rules
	tCtrls["num"]["num_9"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_5"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_6"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_7"]:SetToolTip(tLang.ZeroUnlimited)
	tCtrls["num"]["num_8"]:SetToolTip(tLang.ZeroUnlimited)
	tFuncs.GetCtrl("ID_PANEL10"):Layout()
	-- 11. More deflood
	local tActions2 = {tLang.Disconnect,tLang.Kick,tLang.TempBan,tLang.PermBan}
	TranslateComboBox(tCtrls["num"]["num_30"])
	TranslateComboBox(tCtrls["num"]["num_71"])
	TranslateComboBox(tCtrls["num"]["num_33"])
	TranslateComboBox(tCtrls["num"]["num_36"])
	TranslateComboBox(tCtrls["num"]["num_100"])
	TranslateComboBox(tCtrls["num"]["num_103"])
	local i = tCtrls["num"]["num_52"]:GetSelection()
	tCtrls["num"]["num_52"]:Clear()
	tCtrls["num"]["num_52"]:Append(tActions2)
	tCtrls["num"]["num_52"]:SetSelection(i)
	tFuncs.GetCtrl("ID_PANEL11"):Layout()
	-- 12. More more deflood
	TranslateComboBox(tCtrls["num"]["num_39"])
	TranslateComboBox(tCtrls["num"]["num_74"])
	TranslateComboBox(tCtrls["num"]["num_42"])
	TranslateComboBox(tCtrls["num"]["num_95"])
	TranslateComboBox(tCtrls["num"]["num_98"])
	TranslateComboBox(tCtrls["num"]["num_48"])
	TranslateComboBox(tCtrls["num"]["num_45"])
	TranslateComboBox(tCtrls["num"]["num_77"])
	tCtrls["num"]["num_17"]:SetToolTip(tLang.ZeroUnlimited)
	tFuncs.GetCtrl("ID_PANEL12"):Layout()
	-- Scripts tab
	tCtrls["tab"]:SetPageText(2,tLang.Scripts)
	-- Registered users tab
	tCtrls["tab"]:SetPageText(3,tLang.RegUsers)
	tCtrls["lst_permissions"]:Clear()
	tCtrls["lst_permissions"]:Append({
		tLang.HaveKeyIsOp,tLang.NoGetNickListDeflood,tLang.NoMyINFODeflood,tLang.NoSearchDeflood,
		tLang.NoPMDeflood,tLang.NoMainChatDeflood,tLang.MassMsg,tLang.Topic,
		tLang.TemporaryBan,tLang.RldTxtFiles,tLang.NoTagCheck,tLang.TemporaryUnban,
		tLang.DelRegisteredUser,tLang.AddRegisteredUser,tLang.NoChatLimits,tLang.NoMaxHubsCheck,
		tLang.NoRatioCheck,tLang.NoSlotCheck,tLang.NoShareLimit,tLang.ClearPermBans,
		tLang.ClearTempBans,tLang.GetUserInfo,tLang.GetBans,tLang.StartStopRestartScripts,
		tLang.RestartHub,tLang.TempOP,tLang.GagUngag,tLang.Redir,
		tLang.PermanentBan,tLang.Kick,tLang.Drop,tLang.EntFullHub,
		tLang.AllowLoginBannedIp,tLang.AllowedForOpChat,tLang.SendUsersIP,tLang.RangePermBan,
		tLang.RangeUnbanRangePermUnban,tLang.TempRangeBan,tLang.TempRangeUnban,tLang.GetRangeBans,
		tLang.ClearPermRangeBans,tLang.ClearTempRangeBans,tLang.UnbanPermUnban,tLang.NoSearchLimits,
		tLang.SendLongMyinfos,tLang.DontCheckIP,tLang.Close,tLang.NoCTMDeflood,
		tLang.NoRCTMDeflood,tLang.NoSRDeflood,tLang.NoRecvDeflood,tLang.NoChatInterval,
		tLang.NoPMInterval,tLang.NoSearchInterval,tLang.NoMaxUsersSameIP,tLang.NoReConnTime,
	})
	-- Bans tab
	tCtrls["tab"]:SetPageText(4,tLang.Bans)
	tFuncs.GetCtrl("ID_STB_BANS"):SetLabel(tLang.Bans)
	tFuncs.GetCtrl("ID_STB_RANGEBANS"):SetLabel(tLang.RangeBans)
	-- Texts tab
	tCtrls["tab"]:SetPageText(5,tLang.TextFiles)
	-- UDP debug
	tFuncs.GetCtrl("wxID_CMD_UDPCLEAR"):SetLabel(tLang.ClearAll)
end
