--[[##################################################################################

	PXControl by alex82
	Based on Ptokax Remote Administration by Hungarista

####################################################################################

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

###################################################################################]]

tFuncs.UDPDebugOpen = function()
	tCtrls["tab"]:AddPage(tFuncs.GetCtrl("ID_PNL_UDPDBG"),tLang.UDPDebugger,false,6)
	tCtrls["wxID_TXT_UDPSYS"] = tFuncs.GetCtrl("wxID_TXT_UDPSYS")
	tCtrls["wxID_TXT_UDPERR"] = tFuncs.GetCtrl("wxID_TXT_UDPERR")
	tCtrls["wxID_TXT_UDPLUA"] = tFuncs.GetCtrl("wxID_TXT_UDPLUA")
	tCtrls["wxID_TXT_UDPREG"] = tFuncs.GetCtrl("wxID_TXT_UDPREG")
	tCtrls["wxID_TXT_UDPLOG"] = tFuncs.GetCtrl("wxID_TXT_UDPLOG")
	tFuncs.GetCtrl("ID_PNL_UDPDBG"):Layout()
	tFuncs.UDPEnableHideCtrls(tCfg.UDPDebugPage or "SYS")
	if not wx.wxDirExists(_save_path.."logs") then wx.wxMkdir(_save_path.."logs") end
end

tFuncs.UDPDebugEnable = function(disable)
	if tHubData.bEntered and tHubData.tSettings["txt"][29] then
		if disable or (tData.bUDPDbg and not tCfg.UDPDebug and not tCfg.ScriptErrors) then
			tFuncs.Send("<"..tData.CurrentHub.Nick.."> "..tHubData.tSettings["txt"][29]:sub(1,1).."debug off")
			if tData.UDPClient then
				tData.UDPClient:close()
			end
			tData.bUDPDbg = false
		elseif not tData.bUDPDbg and (tCfg.UDPDebug or tCfg.ScriptErrors) then
			tData.UDPClient,err = socket.udp()
			if not tData.UDPClient then
				wx.wxMessageBox(tLang.UnableToOpenUDPPort.."\n "..tostring(err))
				return
			end
			tData.UDPClient:setsockname("*",tCfg.UDPDebugPort)

			tFuncs.Send("<"..tData.CurrentHub.Nick.."> "..tHubData.tSettings["txt"][29]:sub(1,1).."debug "..tCfg.UDPDebugPort)
			table.insert(tData.tDeadThreads,ThreadCreate(tFuncs.UDPListen,{}))
			tData.bUDPDbg = true
		end
	end
end

tFuncs.UDPEnableHideCtrls = function(sPage)
	tCfg.UDPDebugPage = tCfg.UDPDebugPage or "SYS"
	tFuncs.GetCtrl("wxID_STT_UDPMSG"):SetLabel(tLang.FormatMessages:format(sPage))
	tFuncs.GetCtrl("wxID_TXT_UDP"..tCfg.UDPDebugPage):Hide()
	tFuncs.GetCtrl("wxID_TXT_UDP"..sPage):Show(true)
	local font = tCtrls["app"]:GetFont()
	tFuncs.GetCtrl("wxID_CMD_UDP"..tCfg.UDPDebugPage):Enable(true)
	tCfg.UDPDebugPage = sPage
	tFuncs.GetCtrl("wxID_CMD_UDP"..sPage):Enable(false)
	tFuncs.GetCtrl("wxID_CMD_UDP"..sPage):SetFont(font)
	tFuncs.GetCtrl("ID_PNL_UDPDBG"):Layout()
end

tFuncs.UDPDebugClose = function()
	tFuncs.GetCtrl("wxID_CMD_UDP"..tCfg.UDPDebugPage):Enable(true)
	local font = tCtrls["app"]:GetFont()
	font:SetWeight(wx.wxFONTWEIGHT_NORMAL)
	for i,v in ipairs({"SYS","ERR","LUA","REG","LOG"}) do
		tFuncs.GetCtrl("wxID_CMD_UDP"..v):SetFont(font)
		tFuncs.GetCtrl("wxID_TXT_UDP"..v):Clear()
	end
	if wx.__WXMSW__ then tFuncs.GetCtrl("ID_PNL_UDPDBG"):Hide() end
	tCtrls["tab"]:RemovePage(6)
end

tFuncs.UDPListen = function()
	local BoldIt = function(button)
		local font = tCtrls["app"]:GetFont()
		font:SetWeight(wx.wxFONTWEIGHT_BOLD)
		button:SetFont(font)
	end
	local data,udperr = tData.UDPClient:receive()
	if data then
		local tTypes = {SYS = true,ERR = true,LUA = true,LOG = true,REG = true}
		while not udperr do
			ThreadLockMutex(mutex)
			if tHubData.tSettings["txt"][0] then
				local hubname = data:sub(5,#tHubData.tSettings["txt"][0]+4)
				if hubname == tHubData.tSettings["txt"][0] then
					local sType,msg = data:sub(#tHubData.tSettings["txt"][0]+5):match("^%[(%u%u%u)%]%s(.+)$")
					if sType then
						if tCfg.UDPDebug then
							if not tTypes[sType] then
								sType = "ERR"
							end
							if tCfg.ScriptErrors and sType == "LUA" then
								tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..msg.."\n")
							end
							msg = os.date("[%H:%M:%S] ")..msg.."\n"
							tCtrls["wxID_TXT_UDP"..sType]:AppendText(msg)
							tCtrls["wxID_TXT_UDP"..sType]:ShowPosition(tCtrls["wxID_TXT_UDP"..sType]:GetLastPosition())
							if tCfg.UDPDebugPage ~= sType then BoldIt(tFuncs.GetCtrl("wxID_CMD_UDP"..sType)) end
							if tCfg["UDPLog_"..sType] then
								local file = _save_path.."logs/"..tData.CurrentHub.Name:gsub("%W","_").."_"..sType..".log"
								local f = io.open(file,"a+")
								if f then 
									f:write(msg)
									f:close()
								else tFuncs.SetStatusText(tLang.UnableToOpenLogFile..file) end
							end
						elseif tCfg.ScriptErrors and sType == "LUA" then
							tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..msg.."\n")
						end
					end
				end
			else
				local msg = data:match("^%s*%[LUA%]%s(.+)$")
				if msg then
					tCtrls["txt_scripterror"]:AppendText("["..os.date("%H:%M:%S").."] "..msg.."\n")
				end
			end
			ThreadUnlockMutex(mutex)
			data,udperr = tData.UDPClient:receive()
		end
	end
end
